Ext.define('flextable.Api', {singleton:true, getConnectionInfo:function(moduleId) {
  return this.getStats(moduleId).then(function(statsObject) {
    return (statsObject || {}).connection;
  });
}, getDriverInfo:function(moduleId, params) {
  params = params === undefined ? {mode:'driver'} : params;
  return this.loadInfoData(moduleId, params);
}, getTablesViews:function(moduleId, params) {
  params = params === undefined ? {mode:'tables'} : params;
  return this.loadInfoData(moduleId, params);
}, getTableTypes:function(moduleId, params) {
  params = params === undefined ? {mode:'tableTypes'} : params;
  return this.loadInfoData(moduleId, params);
}, getSchemas:function(moduleId, params) {
  params = params === undefined ? {mode:'schemas'} : params;
  return this.loadInfoData(moduleId, params);
}, getCatalogs:function(moduleId, params) {
  params = params === undefined ? {mode:'catalogs'} : params;
  return this.loadInfoData(moduleId, params);
}, loadInfoData:function(moduleId, params) {
  return flextable.Support.newRequest(flextable.Support.basePath + moduleId + '/info?' + Ext.Object.toQueryString(params), undefined, undefined).then(function(json) {
    json = json || {};
    var meta = json.meta || {};
    return function() {
      var $jscomp$destructuring$var0 = meta;
      var $jscomp$destructuring$var1 = $jscomp$destructuring$var0;
      connection = $jscomp$destructuring$var1.connection;
      return $jscomp$destructuring$var0;
    }();
  }).then(function(statsObject) {
    return (statsObject || {}).connection;
  });
}, getTableMeta:function(moduleId, tableName) {
  return this.loadInfoData(moduleId, {mode:'tableInfo', table:tableName});
}, getStats:function(moduleId, tableName) {
  var params = {};
  if (tableName) {
    params.table = tableName;
  }
  return flextable.Support.newRequest(flextable.Support.basePath + moduleId + '/info?' + Ext.Object.toQueryString(params), undefined, undefined).then(function(json) {
    json = json || {};
    var meta = json.meta || {};
    return function() {
      var $jscomp$destructuring$var2 = meta;
      var $jscomp$destructuring$var3 = $jscomp$destructuring$var2;
      connection = $jscomp$destructuring$var3.connection;
      return $jscomp$destructuring$var2;
    }();
  });
}});
Ext.define('flextable.widget.Wrapper', {extend:'Ext.panel.Panel', alias:'widget.flextableWidget', mixins:['BpcCommon.mixin.Widget'], statics:{WIDGET_NAME:'Flextable Widget', WIDGET_DESCRIPTION:'TableView -  Main / Details', WIDGET_ICON_CLS:'x-fal fa-table'}, widgetConfigSettingMap:{moduleId:{settingType:'moduleInstance'}}, config:{widgetConfiguration:{moduleId:undefined}}, layout:'card', moduleId:undefined, widgetId:undefined, initComponent:function() {
  try {
    this.initWidgetSettings();
  } catch (e) {
  }
  this.callParent(arguments);
  this.initWidget();
  this.settingPanel = this.add({xtype:'bpcSettingPanel', settings:this.settingStore, buttons:[{text:flextable.Support.TR('OK'), handler:this.configureWidget.bind(this)}]});
}, initWidget:function() {
  this.wrapper = this.add(this.moduleId ? {xtype:'flextableMain', moduleId:this.moduleId, isBpcModule:false, showToolbars:false} : {xtype:'container', html:flextable.Support.TR('CONFIG_ERROR_NO_MODULEID_DEFINED'), load:Ext.emptyFn()});
}, refreshWidget:function() {
  this.wrapper.load();
}, configureWidget:function() {
  this.getLayout().setActiveItem(this.settingPanel.isVisible(true) ? this.wrapper : this.settingPanel);
}});
Ext.define('flextable.BpcInterface', {extend:'BpcCommon.BpcInterface', requires:['flextable.widget.Wrapper'], config:{moduleConfigurationComponents:['flextableConfigMain'], requiredModules:[], widgets:['flextable.widget.Wrapper'], version:'4.0.15-SNAPSHOT', build:'v.4.0.14-11-g05ccb7e-2023-03-13T13:12:27+0100'}});
Ext.define('flextable.Module', {singleton:true, constructor:function() {
  BpcCommon.Api.onReady(this.bootstrapFlextable.bind(this));
}, documentsAvailable:false, bootstrapFlextable:function() {
  var $jscomp$this = this;
  var modulesToLoad = ['documents'];
  var modulesAvailablePromises = modulesToLoad.map(function(moduleName) {
    return $jscomp$this.loadAnotherModule(moduleName);
  });
  Promise.all(modulesAvailablePromises).then(function(array) {
    var notLoaded = array.filter(function(i) {
      return i !== true;
    });
    $jscomp$this.documentsAvailable = notLoaded.length <= 0;
    return $jscomp$this.documentsAvailable;
  }).then(function(docsAvailable) {
    if (docsAvailable) {
      flextable.Support.mimeTypeMap['message/rfc822'] = 'fa-envelope';
      flextable.Support.mimeTypeMap['application/zip'] = 'fa-file-archive';
    }
  });
}, loadAnotherModule:function(moduleName) {
  if (window && window[moduleName]) {
    return Promise.resolve(true);
  } else {
    var baseModule = BpcCommon.Api.getBaseModuleIdById(moduleName);
    if (baseModule === moduleName) {
      return new Promise(function(resolve) {
        BpcCommon.Api.loadModule(moduleName).then(function(success) {
          resolve(true);
        }, function(error) {
          resolve(false);
        });
      });
    }
    return Promise.resolve(false);
  }
}, splitValueRenderer:function() {
  Ext.log(this.self.getName() + ': splitValueRenderer');
  try {
    return function(value, metaData, record) {
      if (value && Ext.isDefined(value) && Ext.isString(value)) {
        var array = value.split(',');
        if (array.length > 0) {
          if (array.length > 1) {
            value = array.length + ' Belege';
          }
          var tooltip = '';
          Ext.Array.each(array, function(string) {
            if (array.length === 1) {
              value = string;
            }
            tooltip += string + '\x3cbr\x3e';
          });
          if (metaData) {
            metaData.tdAttr = "data-qtip\x3d'" + tooltip + "'";
          }
        }
      }
      return value;
    };
  } catch (e) {
    Ext.log({msg:this.self.getName() + ': ERROR splitValueRenderer', dump:e, stack:true, level:'error'});
  }
}, special_multi_icon:function() {
  var $jscomp$this = this;
  return function(v, m, r, rI, cI, store, view) {
    if (view) {
      var grid = view.up();
      if (grid) {
        var $jscomp$destructuring$var4 = grid;
        var moduleId = $jscomp$destructuring$var4.moduleId;
        var overWriteIconOnly = false;
        if (!moduleId) {
          moduleId = BpcCommon.Api.getActiveModuleId();
          overWriteIconOnly = true;
        }
        var flextableOrMonitor = BpcCommon.Api.getBaseModuleIdById(moduleId);
        var map;
        if (flextableOrMonitor === 'flextable') {
          var uiConfiguration = BpcCommon.Api.getSetting(moduleId, 'uiConfiguration') || {};
          var $jscomp$destructuring$var5 = uiConfiguration;
          var renderer = $jscomp$destructuring$var5.renderer;
          map = renderer || {};
        } else {
          map = BpcCommon.Api.getSetting(moduleId, 'column_customRenderer') || {};
        }
        var lowerCaseRendererMap = {};
        var lowerCaseRendererKeys = Object.keys(map).map(function(k) {
          var lcRendererName = k.toLowerCase();
          lowerCaseRendererMap[lcRendererName] = map[k] || {iconOnly:true, valueMap:{}};
          return lcRendererName;
        });
        v = v || '';
        var stringArray = v.toLowerCase().split('_');
        var toolTip = [];
        if (stringArray.length % 2 === 0) {
          var rendererArray = [];
          stringArray.map(function(v, index, array) {
            if ((index + 1) % 2 === 0) {
              rendererArray.push({key:array[index - 1], value:v});
            }
          });
          var texts = [];
          rendererArray = rendererArray.map(function(obj) {
            if (lowerCaseRendererMap[obj.key]) {
              var rendererConfig = lowerCaseRendererMap[obj.key];
              var $jscomp$destructuring$var6 = rendererConfig;
              var valueMap = $jscomp$destructuring$var6.valueMap;
              valueMap = valueMap || {};
              if (valueMap[obj.value]) {
                var valueConfig = valueMap[obj.value] || {};
                var $jscomp$destructuring$var7 = valueConfig;
                var iconCls = $jscomp$destructuring$var7.iconCls;
                var color = $jscomp$destructuring$var7.color;
                var label = $jscomp$destructuring$var7.label;
                var tt = {};
                tt[obj.key] = obj.value;
                toolTip.push(tt);
                var rendererText = label || (obj.key || '').toUpperCase() + ' ' + obj.value;
                texts.push(rendererText);
                return $jscomp$this.getSpanForIconCls(iconCls, color);
              }
              return '-1';
            } else {
              return '-1';
            }
          });
          m.tdAttr = "data-qtip\x3d'" + $jscomp$this.arrayToHtmlTable(toolTip) + "'";
          return rendererArray.join('\x26nbsp;') + (overWriteIconOnly ? ' ' + texts.join(' / ') : '');
        } else {
          return v;
        }
      }
    }
    return v;
  };
}, getSpanForIconCls:function(iconCls, color, size) {
  return BpcCommon.util.Icons.getSpanForIconCls(iconCls, color, size);
}, objToTableRow:function(obj) {
  obj = obj === undefined ? {} : obj;
  var html = '';
  Object.keys(obj).map(function(k) {
    html += '\x3ctr\x3e';
    html += '\x3ctd\x3e' + k + '\x3c/td\x3e';
    html += '\x3ctd style\x3d"width: 150px;"\x3e' + obj[k] + '\x3c/td\x3e';
    html += '\x3c/tr\x3e';
  });
  return html;
}, arrayToHtmlTable:function(array) {
  var $jscomp$this = this;
  array = array === undefined ? [] : array;
  var html = '\x3ctable style\x3d"width: 200px;"\x3e';
  html += array.map(function(item) {
    return $jscomp$this.objToTableRow(item);
  }).join('');
  return html + '\x3c/table\x3e';
}});
Ext.define('flextable.Support', {singleton:true, keys:{cfg:'uiConfiguration', id:'idColumn'}, icons:{instance:'fa-th-list', module:'fa-th-list'}, basePath:'/cxf/bpc-flextable/', icon:function(cls) {
  return BpcCommon.util.Icons.getBpcIconCls(cls);
}, defaultFontSize:14, defaultFontUnit:'px', fallbackIconColor:'#eee', marginRight:3, isLegacyIconCls:function(fontAwesomeName) {
  var iconClasses = fontAwesomeName.split(' ');
  return iconClasses.length > 0 && iconClasses.indexOf('fa') !== -1;
}, detailsEnabled:function(moduleId) {
  var detailsTable = BpcCommon.Api.getSetting(moduleId, 'tableNameDetails') || '';
  return detailsTable && detailsTable.length > 0;
}, getResponseObject:function(responseObj) {
  responseObj = responseObj || {};
  if ('responseText' in responseObj && responseObj.responseText) {
    return Ext.decode(responseObj.responseText, true);
  } else {
    if ('responseJson' in responseObj && responseObj.responseJson) {
      return responseObj.responseJson;
    }
  }
}, getSpanForIconCls:function(iconCls, color, size) {
  var legacy = this.isLegacyIconCls(iconCls);
  iconCls = this.icon(iconCls);
  size = size || this.defaultFontSize;
  size += this.defaultFontUnit;
  color = color || this.fallbackIconColor;
  var marginRight = this.marginRight;
  var style = 'color:' + color + ';' + (legacy ? '' : 'font-size:' + size + ';') + 'margin-right:' + marginRight + ';';
  return '\x3cspan class\x3d"' + iconCls + '" style\x3d"' + style + '"\x3e\x3c/span\x3e';
}, newRequest:function(url, params, data, method) {
  params = params === undefined ? {} : params;
  data = data === undefined ? null : data;
  method = method === undefined ? 'GET' : method;
  return new Promise(function(resolve, reject) {
    Ext.Ajax.request({url:url, params:params, method:method, jsonData:data, headers:{'Content-Type':'application/json'}, success:function(response) {
      resolve(flextable.Support.getResponseObject(response));
    }, failure:function(response) {
      reject(response);
    }});
  });
}, TR:function(key) {
  return this.getTranslation(key);
}, translations:{missing:{}}, getMissingTranslations:function() {
  return this.translations.missing;
}, getTranslation:function(key, uppercase, splitWhitespaceWithBr) {
  key = key.toUpperCase();
  var starter = 'FLEXTABLE_';
  if (!Ext.String.startsWith(key, starter)) {
    key = starter + key;
  }
  var translation = BpcCommon.Api.getTranslation(key);
  if (key === translation) {
    this.translations.missing[key] = translation;
  }
  translation = uppercase ? translation.toUpperCase() : translation;
  return splitWhitespaceWithBr ? translation.replace(' ', '\x3cbr\x3e') : translation;
}, getWindow:function(title, iconCls, width, height, cmpAlias, cmpConfig) {
  var w = Ext.create('Ext.window.Window', {title:title || '', height:height || document.body.clientHeight * 0.8, width:width || document.body.clientWidth * 0.6, layout:'fit', iconCls:flextable.Support.icon(iconCls || 'fa-info')});
  cmpConfig = cmpConfig || {};
  cmpConfig.windowReference = w;
  cmpConfig.closeWindow = function() {
    w.close();
  };
  w.add(Ext.create(Ext.apply({xtype:cmpAlias}, cmpConfig)));
  return w;
}, resourcesBasePath:'/bpc-fe-flextable/', getAjaxPromise:function(requestOptions) {
  return new Promise(function(resolve, reject) {
    Ext.Ajax.request(requestOptions).then(function(response) {
      resolve(response);
    }, function(error) {
      reject(error);
    });
  });
}, copyToClipBoard:function(text, extCmp) {
  function copyToClp(stringWithNewLines) {
    try {
      var myFluffyTextarea = document.createElement('textarea');
      myFluffyTextarea.innerHTML = stringWithNewLines;
      var parentElement = document.getElementById(extCmp.getId());
      parentElement.appendChild(myFluffyTextarea);
      myFluffyTextarea.select();
      document.execCommand('copy');
      parentElement.removeChild(myFluffyTextarea);
      return true;
    } catch (e) {
      return false;
    }
  }
  return copyToClp(text);
}, getBackendConnectionId:function(instanceId) {
  return BpcCommon.Api.getSetting(instanceId, 'proxyId');
}, mimeTypeMap:{'application/pdf':'fa-file-pdf', 'text/plain':'fa-file-alt', 'application/vnd.openxmlformats-officedocument.wordprocessingml.document':'fa-file-word', 'application/xml':'fa-file-code', 'text/xml':'fa-file-code', 'application/edifact':'fa-file-code', 'application/vnd.openxmlformats-officedocument.spreadsheetml.sheet':'fa-file-excel', 'other':'fa-file'}, prettyXml:function(xml, tab, nl) {
  tab = tab === undefined ? '\t' : tab;
  nl = nl === undefined ? '\n' : nl;
  var formatted = '', indent = '';
  var nodes = xml.slice(1, -1).split(/>\s*</);
  if (nodes[0][0] === '?') {
    formatted += '\x3c' + nodes.shift() + '\x3e' + nl;
  }
  for (var i = 0; i < nodes.length; i++) {
    var node = nodes[i];
    if (node[0] === '/') {
      indent = indent.slice(tab.length);
    }
    formatted += indent + '\x3c' + node + '\x3e' + nl;
    if (node[0] !== '/' && node[node.length - 1] !== '/' && node.indexOf('\x3c/') === -1) {
      indent += tab;
    }
  }
  return formatted;
}, objectToHtmlTable:function(obj, keys, trPrefix) {
  keys = keys === undefined ? [] : keys;
  trPrefix = trPrefix === undefined ? '' : trPrefix;
  obj = obj || {};
  var html = '\x3ctable style\x3d"width: 300px"\x3e';
  Object.keys(obj).filter(function(k) {
    return keys.length ? keys.indexOf(k) !== -1 : true;
  }).map(function(k) {
    html += '\x3ctr\x3e';
    html += '\x3ctd style\x3d"width: 120px"\x3e' + (trPrefix.length ? flextable.Support.TR(trPrefix + k) : k) + '\x3c/td\x3e';
    html += '\x3ctd style\x3d"width: 180px"\x3e' + obj[k] + '\x3c/td\x3e';
    html += '\x3c/tr\x3e';
  });
  return html + '\x3c/table\x3e';
}, getPluginSourceModuleNames:function() {
  var cfg = BpcCommon.Api.getSetting('flextable', 'plugin_configuration') || [];
  var sourceModuleNames = cfg.filter(function(cfg) {
    return Ext.isDefined(cfg.sourceModule) && cfg.sourceModule !== null;
  }).map(function(cfg) {
    return cfg.sourceModule;
  });
  return Ext.Array.unique(sourceModuleNames);
}, preloadPluginModules:function(moduleId) {
  var $jscomp$this = this;
  var sourceModuleNames = this.getPluginSourceModuleNames();
  var pluginSettingValuesForModuleId = moduleId ? this.getPlugins(moduleId) : [];
  if (this.pluginMap[moduleId]) {
    return Promise.resolve(JSON.parse(JSON.stringify(this.pluginMap[moduleId])));
  } else {
    var moduleLoadPromises = sourceModuleNames.map(function(moduleName) {
      return BpcCommon.Api.loadModule(moduleName);
    });
    return new Promise(function(resolve) {
      Promise.all(moduleLoadPromises).then(function() {
        $jscomp$this.pluginMap[moduleId] = pluginSettingValuesForModuleId;
        resolve(pluginSettingValuesForModuleId);
      }, function() {
        resolve(false);
      });
    });
  }
}, pluginMap:{}, pluginsLoaded:false, getPlugins:function(instanceId) {
  return (BpcCommon.Api.getSetting('flextable', 'plugin_configuration') || []).filter(function(conf) {
    return Ext.isDefined(conf.targetInstance) && Ext.isArray(conf.targetInstance) && conf.targetInstance.indexOf(instanceId) !== -1;
  });
}});
Ext.define('flextable.components.BaseRemoteGrid', {extend:'Ext.grid.Panel', alias:'widget.flextableBaseGrid', moduleId:undefined, columns:undefined, idKey:undefined, flexContext:undefined, fileActionsHidden:true, openDetailWindow:function(rec) {
  var w = flextable.Support.getWindow(rec.get(BpcCommon.Api.getSetting(this.moduleId, flextable.Support.keys.id)), undefined, undefined, undefined, 'flextableDetailPanel', {record:rec, moduleId:this.moduleId, moduleInstance:this.moduleInstance});
  w.show();
}, getActionColumn:function() {
  return {xtype:'actioncolumn', width:50, items:[]};
}, connectionDetails:{}, getUrl:function() {
  return '';
}, createStore:function(fields, headers, totalProperty, rootProperty) {
  var $jscomp$this = this;
  fields = fields === undefined ? [] : fields;
  var proxy = {type:'ajax', url:this.getUrl(), reader:{type:'json', rootProperty:rootProperty || 'items', totalProperty:totalProperty || 'total'}, listeners:{exception:function(p, response, operation) {
    $jscomp$this.handleError(flextable.Support.getResponseObject(response));
  }}};
  if (headers) {
    proxy.headers = headers;
  }
  return Ext.create('Ext.data.Store', {fields:fields, proxy:proxy, autoLoad:false, _grid:this, columnsAdded:undefined, listeners:{load:function(store, records, success, operation) {
    if (success) {
      if ($jscomp$this.createVirtualId) {
        $jscomp$this.createVirtualIds(records);
      }
      if (!store.columnsAdded) {
        $jscomp$this.setColumnsFromRecord(records.length ? records[0] : Ext.create('Ext.data.Model', {NO_DATA:undefined}));
      }
      $jscomp$this.updateTotal();
      var response = operation.getResponse();
      var json = flextable.Support.getResponseObject(response);
      if (json && json.meta && json.meta.connection) {
        $jscomp$this.connectionDetails = json.meta.connection;
      }
    } else {
      if (!store.columnsAdded) {
        $jscomp$this.setColumnsFromRecord(Ext.create('Ext.data.Model', {NO_DATA:undefined}));
      }
    }
  }}});
}, createVirtualIds:function(records) {
  records = records === undefined ? [] : records;
  var $jscomp$destructuring$var8 = this.virtualIdConfig || {};
  var referenceColumn = $jscomp$destructuring$var8.referenceColumn;
  var sort = $jscomp$destructuring$var8.sort;
  var convert = $jscomp$destructuring$var8.convert;
  records.sort(function(a, b) {
    var vA = a.get(referenceColumn);
    var vB = b.get(referenceColumn);
    if (convert) {
      vA = parseInt(vA);
      vB = parseInt(vB);
    }
    return vA - vB;
  });
  if (sort !== 'ASC') {
    records.reverse();
  }
  records.map(function(r, i) {
    r.set('flexVirtualId', i + 1);
  });
}, createTotalButton:function() {
  var $jscomp$this = this;
  return Ext.create({xtype:'button', iconCls:flextable.Support.icon('fa-database'), text:'0', listeners:{afterRender:function(b) {
    if (BpcCommon.Api.hasUserAnyRole(['bpcadmin'])) {
      Ext.create({xtype:'tooltip', target:b, listeners:{beforeshow:function(tip) {
        tip.setHtml(flextable.Support.objectToHtmlTable($jscomp$this.connectionDetails));
      }}});
    }
  }}});
}, baseRenderer:function(v, m, r) {
  var rendererValue;
  v = v || '';
  if (Ext.isObject(v) || Ext.isArray(v)) {
    rendererValue = JSON.stringify(v, undefined, 4);
  }
  return rendererValue ? rendererValue : v;
}, initComponent:function() {
  this.totalBtn = this.createTotalButton();
  this.viewConfig = {emptyText:flextable.Support.TR('NO_DATA'), enableTextSelection:true, markDirty:false};
  if (this.moduleInstance.showToolbars) {
    this.bbar = [this.totalBtn, {xtype:'tbfill'}];
  }
  this.callParent(arguments);
}, getEngineBaseUrl:function() {
  return this.getHttpConnectionBaseUrl('engineConnection', 'engineBasePath');
}, getHttpConnectionBaseUrl:function(connectionSettingId, pathSettingId) {
  var proxyId = BpcCommon.Api.getSetting(this.moduleId, connectionSettingId);
  return BpcCommon.Api.getBackendUrl(proxyId) + BpcCommon.Api.getSetting(this.moduleId, pathSettingId);
}, runAction:function(action, record) {
  var cfg = BpcCommon.Api.getSetting(this.moduleId, 'actionConfig') || {};
  var urlParams = {}, url = this.getEngineBaseUrl() + BpcCommon.Api.getSetting(this.moduleId, 'actionListener');
  if (cfg.params && Ext.isObject(cfg.params) && !Ext.isEmpty(cfg.params)) {
    urlParams = Ext.apply(urlParams, cfg.params);
  }
  var actionPrefix = BpcCommon.Api.getSetting(this.moduleId, 'actionColumnPrefix');
  actionPrefix = actionPrefix || '';
  actionPrefix = actionPrefix.toLowerCase();
  urlParams[actionPrefix] = action;
  urlParams.buttonId = actionPrefix;
  url += '?' + Ext.Object.toQueryString(urlParams);
  var data = record.data || {};
  data.tablePrefix = BpcCommon.Api.getSetting(this.moduleId, 'tableNameDetails');
  return Ext.Ajax.request({url:url, headers:{ISPortalUser:BpcCommon.Api.getUserName(), 'X-BPC-ModuleId':this.moduleId}, method:'POST', params:data}).then(function(response) {
    var json = flextable.Support.getResponseObject(response);
    if (json) {
      if (json.success) {
        BpcCommon.Api.showNotification(json.message ? json.message : 'Aktion wurde erfolgreich ausgeführt');
      } else {
        BpcCommon.Api.showNotification(json.message ? json.message : 'Fehler bei der Ausführung der Aktion');
      }
    } else {
      BpcCommon.Api.showNotification('Action: ' + action + ' - Fehler bei der Ausführung - Response Unexpected');
    }
  }, function(response) {
    BpcCommon.Api.showNotification('Action: ' + action + ' - Fehler bei der Ausführung');
  });
}, handleError:function(obj) {
  var $jscomp$destructuring$var9 = obj;
  var error = $jscomp$destructuring$var9.error;
  var message = $jscomp$destructuring$var9.message;
  var details = $jscomp$destructuring$var9.details;
  details = details || {};
  var v = this.getView();
  if (v) {
    v.setEmptyText(error || ' - ');
  }
  try {
    if (details && details.stacktrace) {
      Ext.create('Ext.window.Window', {title:'Flextable Error Window', height:document.body.clientHeight * 0.8, width:document.body.clientWidth * 0.6, layout:'fit', items:[{xtype:'fieldset', title:'Error', layout:{type:'vbox', align:'stretch'}, items:[{xtype:'textfield', fieldLabel:'MESSAGE', value:message}, {xtype:'textarea', grow:true, flex:1, fieldLabel:'STACKTRACE', value:details.stacktrace}]}]}).show();
    }
  } catch (e) {
  }
}, getAttachmentDataIndex:function() {
  return BpcCommon.Api.getSetting(this.moduleId, 'fileColumn') || 'REFERENCE';
}, getAttachment:function(record) {
  var fileDataIndex = this.getAttachmentDataIndex();
  var lowerUpperAsIsProps = BpcCommon.Api.getSetting(this.moduleId, 'lowerUpperAsIsProps');
  if (lowerUpperAsIsProps !== null) {
    lowerUpperAsIsProps = lowerUpperAsIsProps || '';
    if (lowerUpperAsIsProps.toLowerCase() === 'lower') {
      fileDataIndex = fileDataIndex.toLowerCase();
    } else {
      fileDataIndex = fileDataIndex.toUpperCase();
    }
  }
  return record.get(fileDataIndex) || record.get(fileDataIndex.toUpperCase());
}, openAttachment:function(record) {
  var $jscomp$this = this;
  try {
    var r = record;
    var w = this.up('window'), t = undefined, idSuffix = 'fileViewerItemId';
    if (w) {
      t = w.down('tabpanel');
      if (t) {
        var params = flextable.file.getFileParameters(record, this.moduleId);
        var openViewer = t.down('#' + idSuffix + params.childid);
        if (openViewer) {
          t.setActiveTab(openViewer);
          return;
        }
      } else {
        return;
      }
    }
    var v = this.getView();
    v.setLoading(true);
    var wrapper, title = '', openAsTab = !!t;
    flextable.file.getFile(r, this.moduleId).then(function(data) {
      if (data) {
        var $jscomp$destructuring$var10 = data.meta || {};
        var childid = $jscomp$destructuring$var10.childid;
        title = childid ? flextable.Support.TR('DOCUMENT_FROM_STEP') + ': ' + childid : flextable.Support.TR('DOCUMENT_PREVIEW');
        wrapper = flextable.file.getViewer($jscomp$this.moduleId, data);
        if ($jscomp$this.moduleInstance.fileViewerMetaHidden) {
          wrapper.metaField.setVisible(false);
        }
      } else {
      }
    })['catch'](function(e) {
      title = flextable.Support.TR('REQUEST_ERROR');
      var storeData = ['status', 'statusText', 'responseText'].map(function(k) {
        return {key:flextable.Support.TR('ERROR_INFO_REQUEST_' + k.toUpperCase()), value:e[k] || '-1'};
      });
      if (e.request && e.request.url) {
        storeData.push({key:flextable.Support.TR('ERROR_INFO_REQUEST_URL'), value:e.request.url});
      }
      wrapper = $jscomp$this.getErrorPanel(title, storeData, openAsTab);
    })['finally'](function() {
      v.setLoading(false);
      if (t) {
        t.add(wrapper);
        t.setActiveTab(wrapper);
      } else {
        Ext.create('Ext.window.Window', {title:title, height:document.body.clientHeight * 0.5, width:document.body.clientWidth * 0.7, iconCls:flextable.Support.icon('fa-file'), layout:'fit', items:[wrapper]}).show();
      }
    });
  } catch (e) {
  }
}, getErrorPanel:function(title, data, openAsTab) {
  data = data === undefined ? [] : data;
  return Ext.create({xtype:'panel', title:title, header:openAsTab, closable:openAsTab, iconCls:flextable.Support.icon('fa-exclamation-triangle'), layout:'fit', items:[{xtype:'grid', header:false, listeners:{rowdblclick:function(tableView, record) {
    if (flextable.Support.copyToClipBoard(record.get('value'), tableView)) {
      BpcCommon.Api.showNotification(record.get('key') + ' ' + flextable.Support.TR('COPIED_SUCCESS'));
    }
  }}, store:Ext.create('Ext.data.Store', {data:data}), columns:[{dataIndex:'key', text:flextable.Support.TR('KEY'), flex:1, menuDisabled:true}, {dataIndex:'value', text:flextable.Support.TR('VALUE'), flex:3, menuDisabled:true}]}]});
}, getActionColumnConfig:function(moduleId) {
  var $jscomp$this = this;
  var mimetypeDataIndex = 'MIMETYPE', defaultMimetype = 'application/xml';
  var lowerUpperAsIsProps = BpcCommon.Api.getSetting(moduleId, 'lowerUpperAsIsProps');
  if (lowerUpperAsIsProps !== null) {
    lowerUpperAsIsProps = lowerUpperAsIsProps || '';
    if (lowerUpperAsIsProps.toLowerCase() === 'lower') {
      mimetypeDataIndex = mimetypeDataIndex.toLowerCase();
    } else {
      mimetypeDataIndex = mimetypeDataIndex.toUpperCase();
    }
  }
  var items = [{tooltip:flextable.Support.TR('SHOW_DOCUMENT'), scope:this, handler:function(g, r, c, i, e, record) {
    $jscomp$this.openAttachment(record);
  }, isActionDisabled:function(view, rowIndex, colIndex, item, record) {
    return !$jscomp$this.getAttachment(record);
  }, getClass:function(value, metadata, record) {
    var mimeType = record.get(mimetypeDataIndex) || defaultMimetype;
    return flextable.Support.icon(flextable.Support.mimeTypeMap[mimeType] || 'fa-file');
  }}, {iconCls:flextable.Support.icon('fa-download'), tooltip:flextable.Support.TR('DOWNLOAD_DOCUMENT'), handler:function(grid, row, c, i, e, r) {
    try {
      flextable.file.openFile(r, moduleId);
    } catch (e$0) {
      BpcCommon.Api.showNotification(flextable.Support.TR('DOWNLOAD_ERROR'));
    }
  }, isActionDisabled:function(view, rowIndex, colIndex, item, record) {
    return !$jscomp$this.getAttachment(record);
  }}].map(function(i) {
    i.hidden = $jscomp$this.fileActionsHidden || BpcCommon.Api.hasUserRole('FLEXTABLE_NO_FILES');
    return i;
  });
  return [{xtype:'actioncolumn', width:items.filter(function(i) {
    return !i.hidden;
  }).length * 30, items:items}];
}, createRenderer:function(cfg, dataIndex) {
  dataIndex = dataIndex === undefined ? '' : dataIndex;
  cfg = cfg || {};
  var isDate = Ext.isDefined(cfg.isDate) ? cfg.isDate : false;
  if (isDate) {
    var dateCfg = cfg;
    return function(v, m, r) {
      if (!v) {
        return '';
      }
      var rendererValue;
      if (dateCfg.autoParse === false) {
        var date;
        if (dateCfg.timezone) {
          v = r.get(dataIndex + '_STRING');
          v = v.trim() + dateCfg.timezone;
          date = new Date(v);
        } else {
          date = dateCfg.formatInput ? Ext.Date.parse(v, dateCfg.formatInput) : Ext.Date.parse(v);
        }
        if (Ext.isDate(date)) {
          rendererValue = Ext.Date.format(date, dateCfg.format);
        } else {
          var splitted = v.split('+');
          if (splitted.length === 2) {
            var tzArray = splitted[1].split(':');
            if (tzArray[0].length === 1) {
              tzArray[0] = '0' + tzArray[0];
            }
            var timeZone = tzArray.join(':');
            var newDateString = splitted[0].trim() + '+' + timeZone;
            newDateString = newDateString.trim();
            var date2 = Ext.Date.parse(newDateString);
            if (date2) {
              rendererValue = Ext.Date.format(date2, dateCfg.format || 'd.m.Y');
            }
          }
        }
      }
      return rendererValue ? rendererValue : v || '';
    };
  }
  var iconOnly = Ext.isDefined(cfg.iconOnly) ? cfg.iconOnly : false;
  var map = cfg.valueMap || {};
  var renderIcon = function(cls, c) {
    return cls ? flextable.Support.getSpanForIconCls(cls, c) : undefined;
  };
  var compareLower = Ext.isDefined(cfg.compareLower) ? cfg.compareLower : false;
  return function(v, m, r) {
    var rendererValue;
    v = v || '';
    v = compareLower ? v.toLowerCase() : v;
    if (map[v]) {
      var item = map[v] || {};
      item = Ext.applyIf(item, {label:undefined, iconOnly:undefined, color:undefined});
      rendererValue = iconOnly ? renderIcon(item.iconCls, item.color) : (renderIcon(item.iconCls, item.color) || '') + ' ' + (item.label || v || '');
    }
    return rendererValue ? rendererValue : v;
  };
}, getColumnsFromSetting:function(mainOrDetails) {
  var $jscomp$this = this;
  var cfg = BpcCommon.Api.getSetting(this.moduleId, 'uiConfiguration') || {};
  var rendererCfg = cfg.renderer || {};
  var lowerUpperAsIsProps = BpcCommon.Api.getSetting(this.moduleId, 'lowerUpperAsIsProps') || null;
  if (cfg[mainOrDetails] && cfg[mainOrDetails].columns) {
    if (cfg[mainOrDetails].fileActionsHidden) {
      this.fileActionsHidden = true;
    }
    return cfg[mainOrDetails].columns.map(function(colCfg) {
      try {
        var $jscomp$destructuring$var11 = colCfg;
        var dataIndex = $jscomp$destructuring$var11.dataIndex;
        var targetDataIndex = dataIndex;
        if (lowerUpperAsIsProps !== null) {
          if (lowerUpperAsIsProps.toLowerCase() === 'lower') {
            targetDataIndex = targetDataIndex.toLowerCase();
          } else {
            targetDataIndex = targetDataIndex.toUpperCase();
          }
        }
        if (colCfg.renderer) {
          colCfg.renderer = flextable.Module[colCfg.renderer]();
        } else {
          var renderer = dataIndex && rendererCfg[dataIndex] ? $jscomp$this.createRenderer(rendererCfg[dataIndex] || {}, targetDataIndex) : undefined;
          if (renderer) {
            colCfg.renderer = renderer;
          }
        }
      } catch (e) {
      }
      if (lowerUpperAsIsProps !== null) {
        var $jscomp$destructuring$var12 = colCfg;
        var dataIndex$1 = $jscomp$destructuring$var12.dataIndex;
        lowerUpperAsIsProps = lowerUpperAsIsProps || '';
        if (lowerUpperAsIsProps.toLowerCase() === 'lower') {
          dataIndex$1 = dataIndex$1.toLowerCase();
        } else {
          dataIndex$1 = dataIndex$1.toUpperCase();
        }
        colCfg.dataIndex = dataIndex$1;
      }
      return colCfg;
    });
  }
}, changeExtraParams:function(params) {
  var p = this.store.getProxy().getExtraParams() || {};
  p = Ext.apply(p, params);
  this.store.getProxy().setExtraParams(p);
  this.store.load();
}, setColumnsFromRecord:function(rec) {
  var $jscomp$this = this;
  var obj = rec ? rec.getData() : {};
  var columns = Object.keys(obj).filter(function(name) {
    return name !== 'id';
  }).map(function(name) {
    return {dataIndex:name, text:name.toUpperCase(), flex:1, renderer:$jscomp$this.baseRenderer};
  });
  this.reconfigure(columns);
  this.store.addColumns = true;
}, updateTotal:function(num) {
  var total = num || this.store.getTotalCount();
  this.totalBtn.setText(String(total) + ' ' + flextable.Support.TR('ROWS'));
}, getPluginDefinitions:function() {
  var h = Ext.createByAlias('widget.flextableGridActionHook', {hidden:true, context:{moduleId:'flextable', instanceId:this.moduleId}});
  return h.getPluginDefinitions();
}});
Ext.define('flextable.components.DetailPanel', {extend:'Ext.panel.Panel', alias:'widget.flextableDetailPanel', layout:{type:'vbox', align:'stretch'}, header:false, initComponent:function() {
  var defaults = {record:this.record, moduleInstance:this.moduleInstance};
  var containerBase = {xtype:'container', layout:'fit', items:[], flex:1};
  this.topContainer = Ext.create(Ext.apply({}, containerBase, defaults));
  this.mainContainer = Ext.create(Ext.apply({}, containerBase, defaults));
  this.items = [this.topContainer, {xtype:'splitter'}, this.mainContainer];
  this.callParent(arguments);
  var processViewerCmp = this.topContainer.add(Ext.apply({xtype:'flextableProcessViewer', header:false}, defaults));
  var detailsEnabled = flextable.Support.detailsEnabled(this.moduleId);
  if (detailsEnabled) {
    var tabPanel = this.mainContainer.add({xtype:'tabpanel'});
    var detailGrid = tabPanel.add({xtype:'flextableGrid', moduleId:this.moduleId, moduleInstance:this.moduleInstance, mode:'details', title:flextable.Support.TR('LOG_STEPS')});
    tabPanel.setActiveTab(detailGrid);
    detailGrid.changeExtraParams({idValue:this.record.get(BpcCommon.Api.getSetting(this.moduleId, flextable.Support.keys.id))});
    detailGrid.store.load();
  }
}});
Ext.define('flextable.components.DynamicHtmlContent', {extend:'Ext.container.Container', alias:'widget.flextableDynamicHtmlContent', url:'', listeners:{boxready:function(c) {
  c.setHtml('\x3ciframe  width\x3d"100%" height\x3d"100%" src\x3d"' + c.url + '"\x3e\x3c/iframe\x3e');
}}, update:function(htmlOrData, loadScripts, callback, scriptScope) {
  var me = this, isData = me.tpl && !Ext.isString(htmlOrData), container = me.ownerFocusableContainer, sizeModel, doLayout, el;
  if (isData) {
    me.data = htmlOrData && htmlOrData.isEntity ? htmlOrData.getData(true) : htmlOrData;
  } else {
    me.html = Ext.isObject(htmlOrData) ? Ext.DomHelper.markup(htmlOrData) : htmlOrData;
  }
  if (me.rendered) {
    sizeModel = me.getSizeModel();
    doLayout = sizeModel.width.shrinkWrap || sizeModel.height.shrinkWrap;
    if (me.isContainer) {
      el = me.layout.getRenderTarget();
      doLayout = doLayout || me.items.items.length > 0;
    } else {
      el = me.getTargetEl();
    }
    if (isData) {
      me.tpl[me.tplWriteMode](el, me.data || {});
    } else {
      el.setHtml = function(html) {
        if (this.dom) {
          this.dom.innerHTML = html;
        }
        return this;
      };
      el.setHtml(me.html, loadScripts, callback, scriptScope || me);
    }
    if (doLayout) {
      me.updateLayout();
    }
    if (container && !container.onFocusableChildUpdate.$nullFn) {
      container.onFocusableChildUpdate(me);
    }
  }
}, setHtml:function(html, loadScripts, callback, scriptScope) {
  this.update(html, loadScripts, null, scriptScope);
}});
Ext.define('flextable.components.Grid', {extend:'flextable.components.BaseRemoteGrid', alias:'widget.flextableGrid', moduleId:undefined, columns:undefined, idKey:undefined, flexContext:undefined, fileActionsHidden:undefined, connectionDetails:{}, createVirtualId:false, getUrl:function() {
  return '/cxf/bpc-flextable/' + this.moduleId + '/data';
}, initComponent:function() {
  var $jscomp$this = this;
  var listeners = {};
  var fieldsDefinition = [];
  if (this.mode === 'details') {
    var idFieldForDetails = BpcCommon.Api.getSetting(this.moduleId, 'idColumnDetailSub');
    fieldsDefinition.push({name:idFieldForDetails, sortType:'asInt'});
  }
  var virtualIdConfig = BpcCommon.Api.getSetting(this.moduleId, 'virtualIdConfig') || {};
  var $jscomp$destructuring$var13 = virtualIdConfig;
  var enabled = $jscomp$destructuring$var13.enabled;
  var referenceColumn = $jscomp$destructuring$var13.referenceColumn;
  var sort = $jscomp$destructuring$var13.sort;
  var convert = $jscomp$destructuring$var13.convert;
  if (enabled) {
    if (referenceColumn && referenceColumn.length) {
      this.createVirtualId = true;
      sort = sort || 'ASC';
      this.virtualIdConfig = {referenceColumn:referenceColumn, sort:sort, convert:convert};
    }
  }
  this.store = this.createStore(fieldsDefinition);
  var definedColumns = this.getColumnsFromSetting(this.mode || 'main');
  var columns = definedColumns ? this.getActionColumnConfig(this.moduleId).concat(definedColumns) : undefined;
  var actionColumn = this.getActionColumn();
  var pluginDefinitions = this.getPluginDefinitions();
  if (pluginDefinitions && pluginDefinitions.length) {
    var instances = pluginDefinitions.map(function(i) {
      return Ext.create(i);
    });
    if (instances.length === 1) {
      var o = instances[0].getPluginAction(this);
      if (o) {
        actionColumn.items.push(o);
      }
    }
  }
  var actionColPrefix = BpcCommon.Api.getSetting(this.moduleId, 'actionColumnPrefix');
  var actionListener = BpcCommon.Api.getSetting(this.moduleId, 'actionListener');
  var actionActive = actionListener !== null && actionListener !== undefined;
  if (actionActive) {
    actionColumn.items.push({iconCls:flextable.Support.icon('fa-play'), tooltip:'Aktionen starten', handler:function(grid, rowIndex, colIndex, item, e, record) {
      var actions = [];
      var actionColumns = Object.keys(record.data).filter(function(i) {
        if (i && Ext.isString(i)) {
          return i.startsWith(actionColPrefix);
        }
        return false;
      }).map(function(name) {
        var actionString = record.get(name);
        actionString.split(',').map(function(i) {
          i = i || '';
          return i.trim();
        }).filter(function(i) {
          return i.length > 0;
        }).map(function(i) {
          actions.push({text:i});
        });
      });
      Ext.create('Ext.menu.Menu', {margin:'0 0 10 0', floating:true, items:actions.map(function(i) {
        i.record = record;
        i.iconCls = flextable.Support.icon('fa-play-circle');
        i.handler = function(m) {
          $jscomp$this.runAction(m.text, m.record);
        };
        return i;
      })}).showAt(e.getXY());
    }, isActionDisabled:function(view, rowIndex, colIndex, item, record) {
      if (record && record.data) {
        var actionColumns = Object.keys(record.data).filter(function(i) {
          if (i && Ext.isString(i)) {
            return i.startsWith(actionColPrefix);
          }
          return false;
        });
        return actionColumns.length === 0;
      }
      return true;
    }});
  }
  if (actionColumn.items.length && columns) {
    actionColumn.width = actionColumn.items.length * 30;
    columns.push(actionColumn);
  }
  this.columns = columns;
  listeners.rowdblclick = function(tableView, record) {
    if ($jscomp$this.moduleInstance.isBpcModule && $jscomp$this.mode !== 'details') {
      $jscomp$this.openDetailWindow(record);
    } else {
      if (!$jscomp$this.moduleInstance.isBpcModule && $jscomp$this.mode === 'details' && $jscomp$this.getAttachment(record)) {
        $jscomp$this.openAttachment(record);
      }
    }
  };
  var detailsEnabled = flextable.Support.detailsEnabled(this.moduleId);
  this.plugins = this.idKey && detailsEnabled ? [{ptype:'rowwidget', widget:{xtype:'container', layout:'fit', items:[]}, _grid:this, onWidgetAttach:function(plugin, cmp, record) {
    cmp.removeAll();
    var gridCmp = cmp.add({xtype:'flextableGrid', moduleId:plugin._grid.moduleId, moduleInstance:plugin._grid.moduleInstance, mode:'details'});
    var $jscomp$destructuring$var14 = plugin._grid || {};
    var moduleId = $jscomp$destructuring$var14.moduleId;
    var idKey = $jscomp$destructuring$var14.idKey;
    var lowerUpperAsIsProps = BpcCommon.Api.getSetting(moduleId, 'lowerUpperAsIsProps');
    if (lowerUpperAsIsProps !== null) {
      if ((lowerUpperAsIsProps || '').toLowerCase() === 'lower') {
        idKey = idKey.toLowerCase();
      } else {
        idKey = idKey.toLowerCase();
      }
    }
    var pid = record.get(idKey);
    if (pid) {
      gridCmp.changeExtraParams({idValue:pid});
      gridCmp.store.load();
    }
  }}] : [];
  this.store.columnsAdded = !!(Ext.isDefined(this.columns) && this.columns.length);
  if (!Ext.isDefined(this.columns)) {
    this.columns = [];
  }
  this.listeners = listeners;
  this.callParent(arguments);
}});
Ext.define('flextable.components.HttpGrid', {extend:'flextable.components.BaseRemoteGrid', alias:'widget.flextableHttpGrid', moduleId:undefined, columns:undefined, idKey:undefined, flexContext:undefined, connectionDetails:{}, getUrl:function() {
  return this.getHttpConnectionBaseUrl('backendConnectionHttp', 'backendConnectionHttpBasePath');
}, initComponent:function() {
  var $jscomp$destructuring$var15 = BpcCommon.Api.getSetting(this.moduleId, 'backendConnectionHttpExtraConfig') || {};
  var headers = $jscomp$destructuring$var15.headers;
  var totalProperty = $jscomp$destructuring$var15.totalProperty;
  var rootProperty = $jscomp$destructuring$var15.rootProperty;
  this.store = this.createStore(undefined, headers, totalProperty, rootProperty);
  this.columns = this.getColumnsFromSetting('main') || [];
  this.store.columnsAdded = this.columns.length > 0;
  this.callParent(arguments);
}, createRenderer:function(cfg) {
  cfg = cfg || {};
  var isDate = Ext.isDefined(cfg.isDate) ? cfg.isDate : false;
  if (isDate) {
    var dateCfg = cfg;
    return function(v, m, r) {
      if (!v) {
        return '';
      }
      var rendererValue;
      if (dateCfg.autoParse === false) {
        var date = dateCfg.formatInput ? Ext.Date.parse(v, dateCfg.formatInput) : Ext.Date.parse(v);
        if (Ext.isDate(date)) {
          rendererValue = Ext.Date.format(date, dateCfg.format);
        } else {
          var splitted = v.split('+');
          if (splitted.length === 2) {
            var tzArray = splitted[1].split(':');
            if (tzArray[0].length === 1) {
              tzArray[0] = '0' + tzArray[0];
            }
            var timeZone = tzArray.join(':');
            var newDateString = splitted[0].trim() + '+' + timeZone;
            newDateString = newDateString.trim();
            var date2 = Ext.Date.parse(newDateString);
            if (date2) {
              rendererValue = Ext.Date.format(date2, dateCfg.format || 'd.m.Y');
            }
          }
        }
      }
      return rendererValue ? rendererValue : v || '';
    };
  }
  var iconOnly = Ext.isDefined(cfg.iconOnly) ? cfg.iconOnly : false;
  var map = cfg.valueMap || {};
  var renderIcon = function(cls, c) {
    return cls ? flextable.Support.getSpanForIconCls(cls, c) : undefined;
  };
  var compareLower = Ext.isDefined(cfg.compareLower) ? cfg.compareLower : false;
  return function(v, m, r) {
    var rendererValue;
    v = v || '';
    v = compareLower ? v.toLowerCase() : v;
    if (map[v]) {
      var item = map[v] || {};
      item = Ext.applyIf(item, {label:undefined, iconOnly:undefined, color:undefined});
      rendererValue = iconOnly ? renderIcon(item.iconCls, item.color) : (renderIcon(item.iconCls, item.color) || '') + ' ' + (item.label || v || '');
    } else {
      if (Ext.isObject(v) || Ext.isArray(v)) {
        rendererValue = JSON.stringify(v, undefined, 4);
      }
    }
    return rendererValue ? rendererValue : v;
  };
}});
Ext.define('flextable.components.field.FieldMixin', {listeners:{change:function(field) {
  var cellEditor = field.up('bpcCellEditor');
  if (cellEditor && cellEditor.isComponent) {
    cellEditor.valueChanged = true;
  }
}}});
Ext.define('flextable.components.field.MainConnectionCombo', {extend:'Ext.form.field.ComboBox', alias:['widget.bpcconfig.flextableMainConnection', 'widget.bpcconfig.flextablemainconnection'], queryMode:'local', valueField:'key', displayField:'value', forceSelection:true, mixins:['flextable.components.field.FieldMixin'], viewModel:{data:{setting:undefined}}, bind:{value:'{setting.value}'}, initComponent:function() {
  this.store = Ext.create('Ext.data.Store', {data:[{key:'backendConnection', value:'DATABASE_CONNECTION'}, {key:'backendConnectionHttp', value:'HTTP_CONNECTION'}]});
  this.getViewModel().set('setting', this.setting);
  this.callParent(arguments);
}});
Ext.define('flextable.file', {singleton:true, getFileParameters:function(record, moduleId) {
  var directoryKey = BpcCommon.Api.getSetting(moduleId, 'fileColumn') || '';
  var processidKey = BpcCommon.Api.getSetting(moduleId, 'idColumnDetail') || '';
  var childidKey = BpcCommon.Api.getSetting(moduleId, 'idColumnDetailSub') || '';
  var mimeKey = BpcCommon.Api.getSetting(moduleId, 'fileMimeColumn') || '';
  var lowerUpperAsIsProps = BpcCommon.Api.getSetting(moduleId, 'lowerUpperAsIsProps');
  if (lowerUpperAsIsProps !== null) {
    lowerUpperAsIsProps = lowerUpperAsIsProps || '';
    if (lowerUpperAsIsProps.toLowerCase() === 'lower') {
      directoryKey = directoryKey.toLowerCase();
      processidKey = processidKey.toLowerCase();
      childidKey = childidKey.toLowerCase();
      mimeKey = mimeKey.toLowerCase();
    } else {
      directoryKey = directoryKey.toUpperCase();
      processidKey = processidKey.toUpperCase();
      childidKey = childidKey.toUpperCase();
      mimeKey = mimeKey.toUpperCase();
    }
  }
  var directory = record.get(directoryKey) || null;
  var processid = record.get(processidKey) || null;
  var childid = record.get(childidKey) || null;
  var mime = record.get(mimeKey) || null;
  var prefix = BpcCommon.Api.getSetting(moduleId, 'tablePrefix') || null;
  return {directory:directory, processid:processid, childid:childid, prefix:prefix, mime:mime};
}, getFileUrl:function(record, moduleId) {
  var params = this.getFileParameters(record, moduleId);
  var proxyId = BpcCommon.Api.getSetting(moduleId, 'engineConnection') || '-1';
  var basePath = BpcCommon.Api.getSetting(moduleId, 'engineBasePath') || '';
  var fileListener = BpcCommon.Api.getSetting(moduleId, 'fileListener') || '';
  var prefix = BpcCommon.Api.getBackendUrl(proxyId) || '';
  return prefix + basePath + fileListener + '?' + Ext.Object.toQueryString(params);
}, getFileResponse:function(url) {
  return flextable.Support.getAjaxPromise({method:'get', url:url});
}, getFile:function(record, moduleId) {
  var $jscomp$this = this;
  var url = this.getFileUrl(record, moduleId);
  return this.getFileResponse(url).then(function(response) {
    if (response && response.responseText) {
      return $jscomp$this.responseToFileInitObject(response, record, moduleId, url);
    }
  });
}, responseToFileInitObject:function(response, record, moduleId, url) {
  return {file:response.responseText, meta:flextable.file.getFileParameters(record, moduleId), record:record, fileSource:response.responseText, fileUrl:url};
}, openFile:function(record, moduleId) {
  window.open(this.getFileUrl(record, moduleId), '_blank');
}, getViewer:function(moduleId, data, idSuffix) {
  data = data === undefined ? {} : data;
  idSuffix = idSuffix === undefined ? 'fileViewerItemId' : idSuffix;
  var fileData = data.file || '';
  if (data.meta.mime) {
    data.meta.forceViewUrl = ['image/png', 'image/jpeg', 'image/bmp', 'image/gif', 'image/jpg', 'application/pdf', 'text/xml'].indexOf(data.meta.mime) !== -1;
    data.meta.isXml = data.file.trim().startsWith('\x3c');
    if (data.meta.mime === 'application/octet-stream') {
      if (data.meta.directory.endsWith('.pdf')) {
        data.meta.mime = 'application/pdf';
        data.meta.isXml = false;
        data.meta.mimeGuess = true;
      }
      if (data.meta.directory.endsWith('.html')) {
        data.meta.mime = 'text/html';
        data.meta.isXml = true;
        data.meta.mimeGuess = true;
      }
      if (data.meta.directory.endsWith('.json')) {
        data.meta.mime = 'application/json';
        data.meta.isXml = false;
        data.meta.mimeGuess = true;
      }
    }
  } else {
    fileData = fileData.trim();
    if (fileData.startsWith('\x3c')) {
      data.meta.mime = 'text/xml';
      data.meta.isXml = true;
      data.meta.mimeGuess = true;
    } else {
      if (fileData.split("'").length > 2) {
        data.meta.mime = 'application/edifact';
        data.meta.mimeGuess = true;
      } else {
      }
    }
  }
  if (data.meta.isXml) {
    data.file = flextable.Support.prettyXml(fileData);
    data.treeView = Ext.create({xtype:'ftTree', fileSource:data.fileSource});
  } else {
    if (data.meta.mime === 'application/edifact') {
      data.file = fileData.split("'").map(function(i) {
        return i.trim();
      }).join("'\r\n");
    } else {
      if (fileData.split("'").length > 2) {
        data.file = fileData.split("'").map(function(i) {
          return i.trim();
        }).join("'\r\n");
      }
    }
  }
  return this.createViewer({moduleId:moduleId, idSuffix:idSuffix, fileObject:data});
}, createViewer:function(cfg) {
  cfg = cfg === undefined ? {} : cfg;
  return Ext.create(Ext.apply({}, {xtype:'ftFileViewer'}, cfg));
}});
Ext.define('flextable.components.fileViewer.FileViewer', {extend:'Ext.panel.Panel', alias:'widget.ftFileViewer', closable:true, header:false, layout:'card', moduleId:undefined, idSuffix:undefined, fileObject:{}, showNotification:function(msg, level) {
  var $jscomp$this = this;
  level = level === undefined ? 'i' : level;
  this.notificationField.update(msg);
  Ext.defer(function() {
    try {
      if (!$jscomp$this.destroyed && $jscomp$this.notificationField && !$jscomp$this.notificationField.destroyed) {
        $jscomp$this.notificationField.update('');
      }
    } catch (e) {
    }
  }, 2000);
}, fetchAsArrayBuffer:function(url) {
  var headers = BpcCommon.Api.getCsrfToken();
  return fetch(url, {headers:headers}).then(function(r) {
    return r.arrayBuffer();
  });
}, arrayBufferToBase64:function(arrayBuffer) {
  return documents.Utils.arrayBufferToBase64(arrayBuffer);
}, getDelegatedComponentCfg:function(mime, base64str) {
  var obj = documents.Utils.getMinimalDocObject(mime, base64str);
  obj.record = Ext.create('Ext.data.Model', {base64string:base64str});
  return documents.Support.getViewerComponentByDocument(obj);
}, initComponent:function() {
  var $jscomp$this = this;
  this.iconCls = flextable.Support.icon('fa-file');
  this.itemId = this.idSuffix + (this.fileObject.meta.childid || Ext.id());
  this.title = this.fileObject.meta.childid ? flextable.Support.TR('DOCUMENT_FROM_STEP') + ': ' + this.fileObject.meta.childid : flextable.Support.TR('DOCUMENT_PREVIEW');
  this.notificationField = Ext.create({xtype:'container'});
  if (this.fileObject.meta) {
    this.metaView = this.createMetaViewer();
  }
  this.metaField = Ext.create({text:flextable.Support.TR('META'), ui:'secondary', xtype:'button', margin:'0 0 0 0', handler:function(b) {
    $jscomp$this.setActiveCard($jscomp$this.metaView);
  }});
  var isHtml = this.fileObject.meta.mime === 'text/html';
  var isPdf = this.fileObject.meta.mime === 'application/pdf';
  var isMail = this.fileObject.meta.mime === 'message/rfc822' && flextable.Module.documentsAvailable;
  var isInternalDtoMail = this.fileObject.meta.mime === 'text/x-bpc-mpm+xml' && flextable.Module.documentsAvailable;
  var isZip = this.fileObject.meta.mime === 'application/zip' && flextable.Module.documentsAvailable;
  var zipButton = Ext.create({xtype:'button', text:flextable.Support.getTranslation('Archive'), iconCls:flextable.Support.icon('fa-file-archive'), margin:'0 2 0 0', ui:'primary', overCls:'', hidden:!isZip, focusCls:'', loadedSuccess:false, pdfCard:undefined, handler:function(btn) {
    if (!btn.loadedSuccess) {
      var mainArrayBuffer = undefined;
      $jscomp$this.fetchAsArrayBuffer($jscomp$this.fileObject.fileUrl).then(function(arrayBuffer) {
        mainArrayBuffer = arrayBuffer;
        return $jscomp$this.arrayBufferToBase64(arrayBuffer);
      }).then(function(base64str) {
        return $jscomp$this.getDelegatedComponentCfg($jscomp$this.fileObject.meta.mime, base64str);
      }).then(function(cmpCfg) {
        cmpCfg.documentsContext = null;
        cmpCfg.mainArrayBuffer = mainArrayBuffer;
        var p = Ext.create(cmpCfg);
        $jscomp$this.setActiveCard(p);
        btn.loadedSuccess = true;
        btn.pdfCard = p;
      });
    } else {
      $jscomp$this.setActiveCard(btn.pdfCard);
    }
  }});
  var mailButton = Ext.create({xtype:'button', text:flextable.Support.TR('Mail'), iconCls:flextable.Support.icon('fa-envelope'), margin:'0 2 0 0', ui:'primary', overCls:'', hidden:!isMail && !isInternalDtoMail, isInternalDtoMail:isInternalDtoMail, focusCls:'', loadedSuccess:false, pdfCard:undefined, handler:function(btn) {
    if (!btn.loadedSuccess) {
      var mainArrayBuffer = undefined, dataUrl = undefined;
      if (btn.isInternalDtoMail) {
        try {
          var sourceString = $jscomp$this.fileObject.fileSource || '';
          var parser = new DOMParser;
          var doc = parser.parseFromString(sourceString, 'application/xml');
          var errorNode = doc.querySelector('parsererror');
          if (errorNode) {
            dataUrl = undefined;
          } else {
            var base64str = doc.querySelector('MIME').innerHTML;
            dataUrl = 'data:application/octet-binary;base64,' + base64str;
          }
        } catch (e) {
          dataUrl = undefined;
        }
      }
      var url = btn.isInternalDtoMail ? dataUrl : $jscomp$this.fileObject.fileUrl;
      var mime = btn.isInternalDtoMail ? 'message/rfc822' : $jscomp$this.fileObject.meta.mime;
      $jscomp$this.fetchAsArrayBuffer(url).then(function(arrayBuffer) {
        mainArrayBuffer = arrayBuffer;
        return $jscomp$this.arrayBufferToBase64(arrayBuffer);
      }).then(function(base64str) {
        return $jscomp$this.getDelegatedComponentCfg(mime, base64str);
      }).then(function(cmpCfg) {
        cmpCfg.documentsContext = null;
        cmpCfg.mainArrayBuffer = mainArrayBuffer;
        var p = Ext.create(cmpCfg);
        $jscomp$this.setActiveCard(p);
        btn.loadedSuccess = true;
        btn.pdfCard = p;
      });
    } else {
      $jscomp$this.setActiveCard(btn.pdfCard);
    }
  }});
  var htmlButton = Ext.create({xtype:'button', text:flextable.Support.TR('HTML'), iconCls:flextable.Support.icon('fa-browser'), margin:'0 2 0 0', ui:'primary', overCls:'', hidden:!isHtml, focusCls:'', loadedSuccess:false, pdfCard:undefined, handler:function(btn) {
    if (!btn.loadedSuccess) {
      var html = $jscomp$this.fileObject.file;
      var url = 'data:text/html,' + encodeURIComponent(html);
      var p = Ext.create({xtype:'panel', layout:'fit', items:[{xtype:'flextableDynamicHtmlContent', url:url}], getValue:function() {
        return html;
      }});
      $jscomp$this.setActiveCard(p);
      btn.loadedSuccess = true;
      btn.pdfCard = p;
    } else {
      $jscomp$this.setActiveCard(btn.pdfCard);
    }
  }});
  var pdfButton = Ext.create({xtype:'button', text:flextable.Support.TR('PDF'), iconCls:flextable.Support.icon('fa-file-pdf'), margin:'0 2 0 0', ui:'primary', overCls:'', hidden:!isPdf, focusCls:'', loadedSuccess:false, pdfCard:undefined, handler:function(btn) {
    if (!btn.loadedSuccess) {
      var p = Ext.create({xtype:'panel', layout:'fit', items:[{xtype:'container', html:flextable.Support.TR('LOADING')}]});
      $jscomp$this.copyButton.setDisabled(true);
      var headers = BpcCommon.Api.getCsrfToken();
      fetch($jscomp$this.fileObject.fileUrl, {headers:headers}).then(function(r) {
        return r.arrayBuffer();
      }).then(function(buffer) {
        var b = new Blob([buffer], {type:'application/pdf'});
        var url = URL.createObjectURL(b);
        var pdfContainer = Ext.create({xtype:'flextableDynamicHtmlContent', url:url});
        p.removeAll();
        p.add(pdfContainer);
        btn.loadedSuccess = true;
        btn.pdfCard = p;
      })['catch'](function() {
        p.removeAll();
        p.add({xtype:'container', html:flextable.Support.TR('ERROR')});
      });
      $jscomp$this.setActiveCard(p);
    } else {
      $jscomp$this.setActiveCard(btn.pdfCard);
    }
  }});
  var originalButton = Ext.create({xtype:'button', text:flextable.Support.TR('ORIGINAL'), iconCls:flextable.Support.icon('fa-file'), margin:'0 2 0 0', ui:'primary', overCls:'', focusCls:'', handler:function() {
    $jscomp$this.setActiveCard($jscomp$this.baseViewer.displayText());
  }});
  var formatButton = Ext.create({xtype:'button', text:flextable.Support.TR('FORMAT'), iconCls:flextable.Support.icon('fa-align-justify'), ui:'primary', margin:'0 2 0 0', overCls:'', focusCls:'', handler:function() {
    $jscomp$this.setActiveCard($jscomp$this.baseViewer.displayText('formatted'));
  }});
  var treeButton = Ext.create({xtype:'button', text:flextable.Support.TR('TREEVIEW'), iconCls:flextable.Support.icon('fa-folder-tree'), ui:'primary', margin:'0 2 0 0', hidden:!this.fileObject.meta.isXml, overCls:'', focusCls:'', cardToShow:this.fileObject.treeView, handler:function(b) {
    $jscomp$this.setActiveCard(b.cardToShow);
  }});
  this.copyButton = Ext.create({xtype:'button', iconCls:flextable.Support.icon('fa-copy'), text:flextable.Support.TR('COPY'), ui:'secondary', margin:'0 2 0 0', handler:function(b) {
    var card = $jscomp$this.getLayout().getActiveItem();
    if (card.getValue) {
      if (flextable.Support.copyToClipBoard(card.getValue(), card)) {
        $jscomp$this.showNotification(flextable.Support.TR('COPIED_SUCCESS'));
      }
    }
  }});
  this.downloadButton = Ext.create({xtype:'button', iconCls:flextable.Support.icon('fa-download'), text:flextable.Support.TR('DOWNLOAD'), ui:'secondary', margin:'0 2 0 0', disabled:!Ext.isDefined(this.moduleId) || this.moduleId === null, handler:function() {
    flextable.file.openFile($jscomp$this.fileObject.record, $jscomp$this.moduleId);
  }});
  if (isHtml || isPdf || isMail || isZip) {
    var buttonsToHide = [formatButton, treeButton];
    if (isPdf || isZip) {
      buttonsToHide.push(originalButton);
    }
    buttonsToHide.map(function(b) {
      return b.setVisible(false);
    });
  }
  this.toolbarTop = Ext.create({xtype:'toolbar', dock:'top', padding:'3 0 3 0', items:[zipButton, htmlButton, pdfButton, mailButton, originalButton, formatButton, treeButton, {xtype:'tbfill'}, this.notificationField, {xtype:'tbfill'}, this.copyButton, this.downloadButton, this.metaField]});
  this.dockedItems = [this.toolbarTop];
  this.baseViewer = this.createBaseViewer();
  this.items = [this.baseViewer];
  this.listeners = {afterrender:function() {
    if (isHtml) {
      htmlButton.handler(htmlButton);
    }
    if (isPdf) {
      pdfButton.handler(pdfButton);
    }
    if (isMail) {
      mailButton.handler(mailButton);
    }
    if (isZip) {
      zipButton.handler(zipButton);
    }
  }};
  this.callParent(arguments);
  if (this.fileObject.remote) {
    this.toolbarTop.hide();
    var loadingPanel = Ext.create({xtype:'panel', layout:'center', items:[{xtype:'panel', header:false, html:'FILE DESCRIPTION', bbar:[{text:flextable.Support.TR('LOAD_AND_SHOW'), ui:'primary', handler:function() {
      $jscomp$this.loadRemoteFile();
    }}]}]});
    this.getLayout().setActiveItem(loadingPanel);
  }
}, remoteFileLoaded:false, loadRemoteFile:function() {
  var $jscomp$this = this;
  if (!this.remoteFileLoaded) {
    if (this.debugEnabled) {
      fetch('/bpc-fe-flextable/resources/examples/single.json').then(function(r) {
        return r.json();
      }).then(function(json) {
        $jscomp$this.remoteFileLoaded = true;
        $jscomp$this.setRemoteFile(json.data[0]);
      });
      return;
    }
    this.fetchRemoteFileData(this.fileObject.remoteFileRequestData.url, this.fileObject.remoteFileRequestData.params).then(function(json) {
      var $jscomp$destructuring$var16 = json;
      var data = $jscomp$destructuring$var16.data;
      data = data || [];
      if (data.length) {
        $jscomp$this.remoteFileLoaded = true;
        $jscomp$this.setRemoteFile(data[0]);
        return;
      }
    }, function(error) {
    });
  }
}, setRemoteFile:function(item) {
  var p = this.fileObject.remoteContentSourceComponent.getViewerForItem(item);
  this.getLayout().setActiveItem(p);
}, fetchRemoteFileData:function(url, params) {
  return Ext.Ajax.request({url:url, params:params, method:'POST'}).then(function(response) {
    return Ext.decode(response.responseText, true);
  }, function(response) {
    return response;
  });
}, setActiveCard:function(card) {
  this.getLayout().setActiveItem(card);
}, createBaseViewer:function() {
  var meta = this.fileObject.meta || {};
  var textView = Ext.create({xtype:'ftText', value:this.fileObject.file ? this.fileObject.file : this.fileObject.fileSource || '-1', mime:meta.mime, readOnly:true});
  return Ext.create({xtype:'container', itemId:'flexFileView', layout:'fit', fileData:this.fileObject, items:[textView], getValue:function() {
    return textView.getValue();
  }, displayText:function(mode) {
    mode = mode === undefined ? 'original' : mode;
    var isJson = this.fileData.meta.mime === 'application/json';
    if (isJson) {
      textView.setAceMode('json');
    }
    if (mode === 'original') {
      textView.setValue(this.fileData.fileSource || '-1');
    } else {
      if (mode === 'formatted') {
        var fileValue = this.fileData.file || '-1';
        try {
          if (isJson) {
            fileValue = JSON.stringify(JSON.parse(fileValue), undefined, 4);
          }
        } catch (e) {
          fileValue = 'ERROR';
        }
        textView.setValue(fileValue);
      }
    }
    return this;
  }});
}, createMetaViewer:function() {
  this.metaView = Ext.create({xtype:'ftFileMeta', fileObject:this.fileObject, viewer:this});
  return this.metaView;
}});
Ext.define('flextable.components.fileViewer.Meta', {extend:'Ext.panel.Panel', alias:'widget.ftFileMeta', moduleId:undefined, fileObject:{}, header:false, flex:1, layout:'fit', hidden:true, scrollable:true, initComponent:function() {
  var metaObject = this.fileObject.meta || {};
  var $jscomp$destructuring$var17 = metaObject;
  var directory = $jscomp$destructuring$var17.directory;
  directory = directory || '';
  var filename = this.getFileNameFromDirectory(directory);
  if (filename) {
    this.updateNotificationField(flextable.Support.TR('FILE') + ': ' + filename);
    metaObject.filename = filename;
  }
  var storeData = Object.keys(metaObject).map(function(k) {
    return {key:k.toUpperCase(), value:metaObject[k] || ''};
  });
  this.items = [{xtype:'grid', store:Ext.create('Ext.data.Store', {data:storeData}), listeners:{rowdblclick:function(tv, rec) {
    var textValue = rec.get('value') || '';
    if (textValue.length > 0 && flextable.Support.copyToClipBoard(textValue, tv)) {
      BpcCommon.Api.showNotification(textValue + ' ' + flextable.Support.TR('COPIED_SUCCESS'));
    }
  }}, columns:[{dataIndex:'key', renderer:function(v) {
    v = v || '';
    return v.length ? '\x3cb\x3e' + v + '\x3c/b\x3e' : v;
  }}, {dataIndex:'value', flex:1}, {xtype:'actioncolumn', width:40, items:[{iconCls:flextable.Support.icon('fa-clone'), tooltip:flextable.Support.TR('COPY'), handler:function(tv, row, c, i, e, r) {
    var textValue = r.get('value') || '';
    if (textValue.length > 0 && flextable.Support.copyToClipBoard(textValue, tv)) {
      BpcCommon.Api.showNotification(textValue + ' ' + flextable.Support.TR('COPIED_SUCCESS'));
    }
  }}]}]}];
  this.callParent(arguments);
}, updateNotificationField:function(str) {
  this.viewer.notificationField.update(str);
}, getFileNameFromDirectory:function(dir) {
  dir = dir === undefined ? '' : dir;
  if (dir.indexOf(':') !== -1) {
    var parts = dir.split(':');
    if (parts.length > 1) {
      var filePart = parts[1] || '';
      if (filePart.indexOf('/') !== -1) {
        var folders = filePart.split('/');
        if (folders.length > 1) {
          var file = folders[1] || '';
          if (file.length) {
            return file;
          }
        }
      }
    }
  }
}});
Ext.define('flextable.components.fileViewer.Text', {extend:'Ext.panel.Panel', alias:'widget.ftText', layout:'fit', editor:undefined, value:undefined, mime:undefined, readOnly:false, initComponent:function() {
  this.editorId = Ext.id();
  var wrapper = Ext.create({xtype:'container', html:'\x3cdiv style\x3d"height: 100%;width: 100%"\x3e\x3cdiv style\x3d"height: 100%;width: 100%" id\x3d"' + this.editorId + '"\x3e\x3c/div\x3e\x3c/div\x3e'});
  this.items = [wrapper];
  this.listeners = {afterrender:this.initEditor.bind(this), beforedestroy:this.destroyEditor.bind(this), resize:this.onResize.bind(this)};
  this.callParent(arguments);
}, initEditor:function() {
  var $jscomp$this = this;
  if (!window.ace) {
    lazyLoad.Ace().then(function() {
      $jscomp$this.initEditor();
    });
    return;
  }
  this.editor = ace.edit(this.editorId);
  this.editor.setTheme('ace/theme/chrome');
  this.setMime(this.mime || 'xml');
  this.editor.setOptions({enableBasicAutocompletion:true, enableLiveAutocompletion:true, showLineNumbers:true, showPrintMargin:false});
  if (this.readOnly) {
    this.editor.setReadOnly(true);
  }
  if (this.value) {
    this.setValue(this.value);
  }
}, setMime:function(mime) {
  mime = mime === undefined ? '' : mime;
  var map = {'application/json':'json', 'application/javascript':'javascript', 'application/ecmascript':'javascript', 'application/edifact':'edifact', 'text/css':'css', 'text/html':'html', 'text/xml':'xml'};
  var editorLanguage = map[mime] || (mime.indexOf('xml') !== -1 ? 'xml' : undefined);
  if (editorLanguage) {
    this.setAceMode(editorLanguage);
  }
}, setAceMode:function(editorLanguage) {
  this.editor.getSession().setMode('ace/mode/' + editorLanguage);
}, onResize:function() {
  if (this.editor) {
    this.editor.resize();
  }
}, getValue:function() {
  if (this.editor) {
    return this.editor.getValue();
  }
}, setValue:function(value) {
  if (this.editor) {
    this.editor.setValue(value, -1);
  }
}, destroyEditor:function() {
  if (this.editor) {
    this.editor.destroy.bind(this.editor);
  }
}});
Ext.define('flextable.components.fileViewer.Tree', {extend:'Ext.tree.Panel', alias:'widget.ftTree', viewConfig:{enableTextSelection:true}, rootVisible:false, scrollable:true, fileSource:undefined, initComponent:function() {
  var $jscomp$this = this;
  var path = Ext.create({xtype:'button', iconCls:flextable.Support.icon('fa-code-branch')});
  var xmlData = this.parseXML(this.fileSource.replace(/<([a-zA-Z0-9]+)(?:xml)ns=".*"(.*)>/g, '\x3c$1$2\x3e').replace(/^\s/, ''));
  var treeStoreData = {};
  try {
    treeStoreData = this.nodeToJsonTree(xmlData);
  } catch (e) {
    treeStoreData = {};
  }
  this.store = Ext.create('Ext.data.TreeStore', {root:{expanded:true, children:treeStoreData}});
  this.bbar = [path];
  this.listeners = {select:function(treeModel, node) {
    Ext.log({dump:node, msg:'select'});
    Ext.log({dump:node.getPath(), msg:'path'});
    var pathString = node.getPath();
    var recordIds = pathString.split('/');
    var namedPath = recordIds.map(function(name) {
      if (name === 'root') {
        return name;
      } else {
        var r = $jscomp$this.store.getById(name);
        if (r) {
          return r.get('text');
        }
        return name;
      }
    });
    path.setText(namedPath.join('/'));
  }, rowdblclick:function(tv, rec) {
    var textValue = rec.get('rawValue') || '';
    if (textValue.length > 0 && flextable.Support.copyToClipBoard(textValue, tv)) {
      BpcCommon.Api.showNotification(textValue + ' ' + flextable.Support.TR('COPIED_SUCCESS'));
    }
  }};
  this.callParent(arguments);
  this.expandAll();
}, columns:[{xtype:'treecolumn', text:'Baum', dataIndex:'text', flex:4}, {text:'Item', dataIndex:'text', hidden:true, flex:1, renderer:function(val, meta, rec) {
  var textValue = rec.get('text') || '';
  return textValue.trim().indexOf(':') !== -1 ? textValue.split(':')[0] : textValue;
}}, {text:'Value', dataIndex:'text', hidden:true, flex:2, renderer:function(val, meta, rec) {
  var textValue = rec.get('text') || '';
  return textValue.trim().indexOf(':') !== -1 ? textValue.split(':')[1] : '';
}}], parseXML:function(dataInString) {
  if (window.DOMParser) {
    return (new window.DOMParser).parseFromString(dataInString, 'text/xml');
  } else {
    if (typeof window.ActiveXObject !== 'undefined' && new window.ActiveXObject('Microsoft.XMLDOM')) {
      var xmlDoc = new window.ActiveXObject('Microsoft.XMLDOM');
      xmlDoc.async = 'false';
      xmlDoc.loadXML(dataInString);
      return xmlDoc;
    }
  }
  return null;
}, nodeToJsonTree:function(node) {
  var jsonTree = {text:node.nodeName, draggable:false};
  var textValue = '';
  Ext.each(node.childNodes, function(item) {
    if (item.nodeType === 3 && item.textContent.trim() !== '') {
      textValue = textValue + item.textContent.trim() + ' ';
      textValue = textValue.replace(/</g, '\x26lt;');
      textValue = textValue.replace(/>/g, '\x26gt;');
    }
  }, this);
  var attributes = '';
  if (node.attributes) {
    for (var i = 0; i < node.attributes.length; i++) {
      attributes = attributes + node.attributes.item(i).name + '\x3d' + node.attributes.item(i).value + ' ';
    }
  }
  if (attributes.length > 0) {
    jsonTree.text = jsonTree.text + ' (' + attributes + ')';
  }
  if (textValue.length > 0) {
    jsonTree.text = jsonTree.text + ' : \x3cb\x3e' + textValue + '\x3c/b\x3e';
    jsonTree.rawValue = textValue || '';
  }
  if (!node.childElementCount || node.childElementCount < 1) {
    jsonTree.leaf = true;
    jsonTree.iconCls = '';
    jsonTree.icon = Ext.BLANK_IMAGE_URL;
  } else {
    jsonTree.leaf = false;
    jsonTree.icon = Ext.BLANK_IMAGE_URL;
    jsonTree.children = [];
    Ext.each(node.childNodes, function(node) {
      if (node.nodeType !== 3) {
        jsonTree.children.push(this.nodeToJsonTree(node));
      }
    }, this);
  }
  return jsonTree;
}});
Ext.define('flextable.components.processViewer.ProcessViewer', {extend:'Ext.panel.Panel', alias:'widget.flextableProcessViewer', layout:{type:'hbox', align:'stretch'}, dataType:'record', record:undefined, moduleInstance:undefined, externalData:undefined, fieldTitle:undefined, initComponent:function() {
  this.defaults = {record:this.record, dataType:this.dataType, moduleInstance:this.moduleInstance, externalData:this.externalData};
  this.fieldSet = this.createFieldset();
  this.items = [this.fieldSet];
  this.flex = 1;
  this.callParent(arguments);
  this.createItemView();
}, createFieldset:function() {
  return Ext.create({xtype:'fieldset', flex:1, title:this.fieldTitle || flextable.Support.TR('DETAILS'), layout:{type:'vbox', align:'stretch'}});
}, createItemView:function() {
  var $jscomp$this = this;
  var obj = this.dataType === 'record' ? this.record.getData() : this.externalData || {};
  Object.keys(obj).filter(function(k) {
    return $jscomp$this.dataType === 'record' ? k !== 'R__' && k !== 'id' : true;
  }).map(function(key) {
    $jscomp$this.fieldSet.add({xtype:'box', html:$jscomp$this.getFlexItem(key, obj[key])});
  });
}, getFlexItem:function(rawKey, rawValue) {
  rawKey = rawKey || '';
  rawValue = rawValue || '';
  if (this.dataType === 'record' && this.moduleInstance) {
    var columns = this.moduleInstance.getColumn(rawKey);
    if (columns.length && columns[0].renderer) {
      rawValue = columns[0].renderer(rawValue);
      rawKey = columns[0].text || rawKey;
    }
  }
  return '\x3cdiv style\x3d"display: flex; flex-direction: row"\x3e\x3cdiv style\x3d"flex-grow: 1;max-width: 15%"\x3e' + rawKey + ': \x3c/div\x3e\x3cdiv style\x3d"flex-grow: 3"\x3e' + rawValue + '\x3c/div\x3e\x3c/div\x3e';
}});
Ext.define('flextable.moduleConfigurationComponents.Main', {extend:'BpcCommon.component.panel.moduleConfigurationComponents.Wrapper', alias:'widget.flextableConfigMain', initComponent:function() {
  this.callParent(arguments);
  this.setIconCls(flextable.Support.icon('fa-database'));
  this.setTitle(flextable.Support.TR('FLEXTABLE_ADMIN'));
  this.saveButton.setVisible(false);
  this.resetButton.setVisible(false);
}, onSelect:function(grid, record) {
  this.settingsWrapper.removeAll();
  var moduleId = record.get('moduleId');
  this.settingsWrapper.add({xtype:'flextableTable', moduleId:moduleId, header:false});
}, getRendererConfig:function(moduleId) {
  var $jscomp$destructuring$var18 = BpcCommon.Api.getSetting(moduleId, flextable.Support.keys.cfg) || {};
  var renderer = $jscomp$destructuring$var18.renderer;
  return renderer || {};
}});
Ext.define('flextable.manager.Renderer', {extend:'Ext.panel.Panel', alias:'widget.flextableRenderer', title:'Renderer', viewConfig:{enableTextSelection:true}, layout:{type:'vbox', align:'stretch'}, initComponent:function() {
  var $jscomp$this = this;
  var conf = BpcCommon.Api.getSetting(this.moduleId, flextable.Support.keys.cfg) || {};
  var $jscomp$destructuring$var19 = conf;
  var renderer = $jscomp$destructuring$var19.renderer;
  var main = $jscomp$destructuring$var19.main;
  var details = $jscomp$destructuring$var19.details;
  renderer = renderer || {};
  main = main || {};
  details = details || {};
  var rendererNames = Object.keys(renderer || {});
  this.rendererStoreData = rendererNames.map(function(name) {
    var map = renderer[name].valueMap || {};
    return {id:name, data:Object.keys(map).map(function(value) {
      var item = map[value] || {};
      item.value = value;
      return item;
    })};
  });
  this.rendererGrid = Ext.create({title:'\x3e ' + (rendererNames.length ? rendererNames[0] : flextable.Support.TR('NO_RENDERER_DEFINED')), xtype:'grid', flex:1, viewConfig:{emptyText:flextable.Support.TR('NO_DATA')}, store:Ext.create('Ext.data.Store', {data:rendererNames.length ? this.rendererStoreData.filter(function(item) {
    return item.id === rendererNames[0];
  })[0].data : []}), columns:['value', 'label', 'iconCls', 'color'].map(function(id) {
    var col = {dataIndex:id, text:id.toUpperCase(), flex:id === 'label' || id === 'value' ? 2 : 1};
    if (id === 'iconCls') {
      col.renderer = function(v, m, r) {
        return flextable.Support.getSpanForIconCls(v, r.get('color'));
      };
    }
    return col;
  }).concat([{xtype:'actioncolumn', width:60, items:[{iconCls:flextable.Support.icon('fa-copy'), handler:function(tv, rowIndex, colIndex) {
    var data = tv.store.getAt(rowIndex).getData();
    tv.store.add({value:data.value || '', iconCls:data.iconCls || '', label:data.label || '', color:data.color || '#eee'});
  }}, {iconCls:flextable.Support.icon('fa-times'), handler:function(tv, rowIndex, colIndex) {
    tv.store.removeAt(rowIndex);
  }}]}]), tbar:[{xtype:'checkbox', margin:'0 0 0 5', boxLabel:flextable.Support.TR('ICON_ONLY')}, {xtype:'checkbox', margin:'0 0 0 5', boxLabel:flextable.Support.TR('COMPARE_LOWER')}, {xtype:'tbfill'}, {text:flextable.Support.TR('ADD_EMPTY')}, {text:flextable.Support.TR('ADD_MATCH_ALL_FALLBACK')}], bbar:[{text:'Usages: '}, {xtype:'tbfill'}, {iconCls:flextable.Support.icon('fa-save')}]});
  this.items = [this.rendererGrid];
  var getCount = function(cols, dataIndex) {
    cols = cols || [];
    return cols.filter(function(col) {
      return col.dataIndex === dataIndex;
    }).length;
  };
  var getTitle = function(dataIndex) {
    return '\x3e ' + dataIndex;
  };
  this.tbar = rendererNames.map(function(name) {
    return {text:name, rendererBtn:true, scope:$jscomp$this, handler:function(b) {
      this.rendererGrid.store.removeAll();
      this.rendererGrid.setTitle(getTitle(b.text));
      this.rendererGrid.store.add(this.rendererStoreData.filter(function(item) {
        return item.id === b.text;
      })[0].data || []);
    }};
  }).concat([{xtype:'tbfill'}, {text:flextable.Support.TR('REMOVE_ALL'), handler:function(btn) {
    this.rendererGrid.setTitle(flextable.Support.TR('NO_RENDERER'));
    this.rendererGrid.store.removeAll();
    this.rendererStoreData = [];
    this.query('button[rendererBtn]').map(function(b) {
      return b.destroy();
    });
  }.bind(this)}]);
  this.callParent(arguments);
}});
Ext.define('flextable.manager.Table', {extend:'Ext.panel.Panel', alias:'widget.flextableTable', layout:{type:'vbox', align:'stretch'}, initComponent:function() {
  var $jscomp$this = this;
  this.title = flextable.Support.TR('CONNECTION_INFO');
  this.iconCls = flextable.Support.icon('fa-ethernet');
  this.connectionInfoPanelToolbar = Ext.create({xtype:'toolbar'});
  this.connectionInfoPanel = Ext.create({xtype:'fieldset', title:flextable.Support.TR('CONNECTION_DETAILS'), layout:'fit', items:[this.connectionInfoPanelToolbar]});
  this.primaryStore = Ext.create('Ext.data.Store', {data:[]});
  this.columnStore = Ext.create('Ext.data.Store', {data:[]});
  this.tableTypesStore = Ext.create('Ext.data.Store', {data:[]});
  this.schemaFieldSet = Ext.create(this.getFieldsetColumn(flextable.Support.TR('TABLES_SCHEMAS'), 'schemaName', [{dataIndex:'TABLE_SCHEM', flex:1}, {dataIndex:'TABLE_CATALOG', flex:1, hidden:true}], 'TABLE_SCHEM', [{xtype:'button', iconCls:flextable.Support.icon('fa-sync'), tooltip:'Schemas \x26 Catalogs', ui:'secondary', handler:function() {
    $jscomp$this.loadSchemasAndCatalogs().then(function(success) {
    });
  }}]));
  this.schemaFieldSet.selectField.on('change', function(f, newVal) {
    var b = $jscomp$this.down('#tableViewsBtn');
    if (b) {
      b.enable();
      b.handler(b);
    }
  });
  this.defaultDatabaseTypes = BpcCommon.Api.getSetting(this.moduleId, 'defaultTableTypes') || ['VIEW', 'TABLE'];
  this.catalogsFieldSet = Ext.create(this.getFieldsetColumn(flextable.Support.TR('TABLES_CATALOGS'), 'catalogName', [{dataIndex:'TABLE_CAT', flex:1}], 'TABLE_CAT'));
  var tableFieldSet = this.getFieldsetColumn(flextable.Support.TR('TABLES_VIEWS'), 'tableViewName', [{dataIndex:'TABLE_NAME', flex:1}, {dataIndex:'type'}], 'TABLE_NAME', [{iconCls:flextable.Support.icon('fa-plus'), ui:'secondary', disabled:true, handler:function() {
  }}, {iconCls:flextable.Support.icon('fa-cog'), ui:'secondary', tooltip:'Change table types filter', handler:function() {
    flextable.Api.getTableTypes($jscomp$this.moduleId).then(function(data) {
      var $jscomp$destructuring$var20 = data;
      var tableTypes = $jscomp$destructuring$var20.tableTypes;
      tableTypes = tableTypes || [];
      tableTypes = tableTypes.map(function(typeObj) {
        var $jscomp$destructuring$var21 = typeObj;
        var TYPE = $jscomp$destructuring$var21.TYPE;
        typeObj.selected = $jscomp$this.defaultDatabaseTypes.indexOf(TYPE) !== -1;
        return typeObj;
      });
      return tableTypes;
    }).then(function(tableTypes) {
      var typesStore = Ext.create('Ext.data.Store', {data:tableTypes});
      return Ext.create('Ext.window.Window', {title:'Types', height:document.body.clientHeight * 0.8, width:document.body.clientWidth * 0.5, layout:'fit', items:[{xtype:'grid', store:typesStore, columns:[{xtype:'checkcolumn', dataIndex:'selected', text:'Selected'}, {dataIndex:'TYPE', flex:1, text:'Type'}]}], bbar:[{xtype:'tbfill'}, {ui:'secondary', iconCls:flextable.Support.icon('fa-save'), text:flextable.Support.TR('SAVE')}, {ui:'primary', iconCls:flextable.Support.icon('fa-sync'), text:flextable.Support.TR('APPLY'), 
      handler:function(b) {
        var newTypes = [];
        typesStore.each(function(r) {
          if (r.get('selected')) {
            newTypes.push(r.get('TYPE'));
          }
        });
        $jscomp$this.defaultDatabaseTypes = newTypes;
        $jscomp$this.loadTablesAndViews();
        b.up('window').close();
      }}]});
    }).then(function(win) {
      win.show();
    });
  }}, {xtype:'button', iconCls:flextable.Support.icon('fa-sync'), tooltip:'Tables \x26 Views', itemId:'tableViewsBtn', ui:'secondary', handler:function() {
    $jscomp$this.loadTablesAndViews($jscomp$this.defaultDatabaseTypes);
  }, disabled:true}]);
  tableFieldSet.selectField.on('change', function(f, newVal) {
    $jscomp$this.primaryStore.removeAll();
    $jscomp$this.columnStore.removeAll();
    if (newVal && newVal.length) {
      flextable.Api.getTableMeta($jscomp$this.moduleId, newVal).then(function(obj) {
        $jscomp$this.primaryStore.add(obj.tableColumnPrimaryKeys || []);
        $jscomp$this.columnStore.add(obj.tableColumnDetails || []);
      });
    }
  });
  this.tableViewsFieldSet = Ext.create(tableFieldSet);
  this.items = [this.connectionInfoPanel, {xtype:'panel', flex:2, layout:{type:'hbox', align:'stretch'}, items:[this.schemaFieldSet, this.catalogsFieldSet, this.tableViewsFieldSet, {xtype:'fieldset', flex:2, title:flextable.Support.TR('TABLE_DETAILS'), layout:{type:'vbox', align:'stretch'}, items:[{xtype:'grid', viewConfig:{emptyText:flextable.Support.TR('NO_DATA')}, minHeight:100, title:flextable.Support.TR('PRIMARY_KEYS'), iconCls:flextable.Support.icon('fa-star-of-life'), store:this.primaryStore, 
  style:'border:0px!important;', columns:[{dataIndex:'COLUMN_NAME', flex:1}, {dataIndex:'PK_NAME', flex:1}]}, {xtype:'grid', flex:2, title:flextable.Support.TR('COLUMN_INFO'), iconCls:flextable.Support.icon('fa-columns'), store:this.columnStore, style:'border:0px!important;', viewConfig:{emptyText:flextable.Support.TR('NO_DATA')}, columns:[{dataIndex:'COLUMN_NAME', flex:1}, {dataIndex:'DATA_TYPE_NAME', flex:1}, {dataIndex:'DATA_TYPE'}, {dataIndex:'IS_AUTOINCREMENT', hidden:true}, {dataIndex:'IS_NULLABLE', 
  hidden:true}, {dataIndex:'COLUMN_SIZE', hidden:true}].map(function(c) {
    c.renderer = function(v, m, r) {
      var data = r.getData();
      if (data.id) {
        delete data.id;
      }
      var tooltip = {};
      Object.keys(data).map(function(propName) {
        tooltip[flextable.Support.TR(propName)] = data[propName];
      });
      m.tdAttr = "data-qtip\x3d'" + flextable.Module.arrayToHtmlTable([tooltip]) + "'";
      return v;
    };
    return c;
  })}]}]}];
  this.callParent(arguments);
  this.loadDriverData();
}, getFieldsetColumn:function(title, itemId, columns, selectRecordField, buttons) {
  columns = columns === undefined ? [] : columns;
  buttons = buttons === undefined ? [] : buttons;
  var selectField = Ext.create({xtype:'textfield', emptyText:title, itemId:itemId + 'Field', flex:1});
  var totalBtn = Ext.create({xtype:'button', iconCls:flextable.Support.icon('fa-database'), text:'0'});
  var store = Ext.create('Ext.data.Store', {data:[], listeners:{datachanged:function(s) {
    totalBtn.setText('' + s.getCount());
  }}});
  var grid = Ext.create({xtype:'grid', style:'border:0px!important;', viewConfig:{emptyText:flextable.Support.TR('NO_DATA')}, tbar:[selectField], bbar:[totalBtn, {xtype:'tbfill'}].concat(buttons), store:store, columns:columns, listeners:{select:function(selModel, r) {
    selectField.setValue(r.get(selectRecordField));
  }}});
  return {xtype:'fieldset', title:title, flex:1, layout:'fit', selectField:selectField, grid:grid, itemId:itemId, items:[grid]};
}, loadTablesAndViews:function(types) {
  var $jscomp$this = this;
  types = types === undefined ? this.defaultDatabaseTypes : types;
  this.tableViewsFieldSet.grid.store.removeAll();
  flextable.Api.getTablesViews(this.moduleId, {mode:'tablesViews', types:types.join(','), schemaName:this.schemaFieldSet.selectField.getValue()}).then(function(data) {
    var storeData = [];
    Object.keys(data).map(function(key) {
      storeData = storeData.concat(data[key]);
    });
    $jscomp$this.tableViewsFieldSet.grid.store.add(storeData);
  });
}, loadSchemasAndCatalogs:function() {
  var $jscomp$this = this;
  return flextable.Api.getSchemas(this.moduleId).then(function(data) {
    $jscomp$this.schemaFieldSet.grid.store.removeAll();
    $jscomp$this.schemaFieldSet.grid.store.add(data.schemas || []);
  }).then(function() {
    return flextable.Api.getCatalogs($jscomp$this.moduleId);
  }).then(function(data) {
    $jscomp$this.catalogsFieldSet.grid.store.removeAll();
    $jscomp$this.catalogsFieldSet.grid.store.add(data.catalogs || []);
  }).then(function() {
    return true;
  });
}, loadDriverData:function() {
  var $jscomp$this = this;
  this.setLoading(flextable.Support.TR('FETCHING_DATA'));
  flextable.Api.getDriverInfo(this.moduleId).then(function(connectionObject) {
    var driver = (connectionObject || {}).driver || {};
    Object.keys(driver).map(function(propName) {
      $jscomp$this.connectionInfoPanelToolbar.add({xtype:'textfield', fieldLabel:flextable.Support.TR('DB_' + propName), value:driver[propName] || '-1', readOnly:true, flex:1});
    });
  }).then(function() {
  })['catch'](function(e) {
  })['finally'](function() {
    $jscomp$this.setLoading(false);
  });
}});
Ext.define('flextable.plugin.BpcPluginMixin', {getValueFromPluginConfiguration:function(key, fromContext) {
  if (this.pluginConfiguration && Ext.isObject(this.pluginConfiguration)) {
    if (!fromContext) {
      var $jscomp$destructuring$var22 = this.pluginConfiguration;
      var configuration = $jscomp$destructuring$var22.configuration;
      configuration = configuration || {};
      if (key in configuration && configuration[key]) {
        return configuration[key];
      }
    } else {
      if (fromContext) {
        if (flextable.util.BpcSupport.versionStartsWith('4.1')) {
          var supportMap = {moduleId:'baseModuleId', instanceId:'moduleId'};
          if (supportMap.hasOwnProperty(key || '')) {
            key = supportMap[key];
          }
        }
        var $jscomp$destructuring$var23 = this.pluginConfiguration;
        var context = $jscomp$destructuring$var23.context;
        context = context || {};
        if (key in context && context[key]) {
          return context[key];
        }
      }
    }
  }
}, getHookTargetCmp:function() {
  var hookCmp = this.getValueFromPluginConfiguration('hook', true);
  return hookCmp.ownerCt ? hookCmp.ownerCt : undefined;
}, isCmpUsedAsPlugin:function() {
  var me = this;
  return 'pluginConfiguration' in me && me.pluginConfiguration && Ext.isObject(me.pluginConfiguration);
}});
Ext.define('flextable.plugin.detailWindow.Main', {extend:'Ext.panel.Panel', alias:'widget.flextablePlugin', mixins:['flextable.plugin.BpcPluginMixin'], layout:'fit', padding:'5 5 5 5', idValue:undefined, legacy:false, flexTableParams:undefined, previewFileWrapperItemId:undefined, baseTitle:'', forceActiveTab:false, initComponent:function() {
  var $jscomp$this = this;
  this.iconCls = flextable.Support.icon(this.getValueFromPluginConfiguration('iconCls') || 'fa-database');
  this.moduleId = this.getValueFromPluginConfiguration('moduleId') || undefined;
  var pTargetModuleId = this.getValueFromPluginConfiguration('instanceId', true);
  var rec = this.getValueFromPluginConfiguration('record', true);
  this.baseTitle = this.getValueFromPluginConfiguration('title');
  this.idValue = rec.get(BpcCommon.Api.getSetting(pTargetModuleId, 'column_id'));
  this.pluginSortColumn = this.getValueFromPluginConfiguration('sortColumn') || BpcCommon.Api.getSetting(this.moduleId, 'sortColumn');
  this.pluginSortDirection = this.getValueFromPluginConfiguration('sortDirection') || BpcCommon.Api.getSetting(this.moduleId, 'sortDirection');
  this.previewFileWrapperItemId = this.getValueFromPluginConfiguration('previewFileWrapperItemId');
  var forceActiveTab = this.getValueFromPluginConfiguration('forceActiveTab');
  if (forceActiveTab === true) {
    this.forceActiveTab = true;
  }
  var metaHidden = this.getValueFromPluginConfiguration('fileViewer_metaHidden');
  this.flextable = Ext.create({xtype:'flextableMain', isBpcModule:false, moduleId:this.moduleId, fileViewerMetaHidden:metaHidden === true, showToolbars:false, idKey:Ext.isDefined(this.idValue) ? false : undefined, onTableCreated:this.onTableCreated.bind(this)});
  this.listeners = {added:function(c, owner) {
    var types = owner.getXTypes();
    types = types.split('/').map(function(t) {
      return t.toLowerCase();
    });
    if ($jscomp$this.forceActiveTab && types.indexOf('tabpanel') !== -1) {
      Ext.defer(function() {
        owner.setActiveTab(c);
      }, 1000);
      return;
    } else {
      var layout = owner.getLayout();
      if (layout && layout.config) {
        var $jscomp$destructuring$var24 = layout;
        var config = $jscomp$destructuring$var24.config;
        config = config || {};
        var $jscomp$destructuring$var25 = config;
        var type = $jscomp$destructuring$var25.type;
        type = type || '';
        if (type === 'hbox' || type === 'vbox') {
          c.setFlex(1);
          return;
        }
      }
      if (c.header) {
        c.header.hide();
      } else {
        c.header = false;
      }
    }
  }};
  this.items = [this.flextable];
  this.callParent(arguments);
  this.updateTitle();
}, onTableCreated:function() {
  var $jscomp$this = this;
  if (Ext.isDefined(this.idValue)) {
    this.flextable.grid.changeExtraParams({idValue:this.idValue});
    this.flextable.grid.flexContext = {processId:this.idValue};
  }
  this.flextable.grid.store.on('load', function(s, records, success) {
    if ($jscomp$this.pluginSortColumn && $jscomp$this.pluginSortColumn.length) {
      s.sort({property:$jscomp$this.pluginSortColumn, direction:$jscomp$this.pluginSortDirection});
    }
    $jscomp$this.updateTitle(success ? records.length : 0);
    if (success) {
      if ($jscomp$this.previewFileWrapperItemId) {
        if ($jscomp$this.ownerCt) {
          var win = $jscomp$this.ownerCt.up('window');
          if (win) {
            var wrapper = win.down('#' + $jscomp$this.previewFileWrapperItemId);
            if (wrapper) {
              wrapper.removeAll();
              var storeData = $jscomp$this.getAttachments(records);
              storeData = storeData.map(function(o) {
                var newObj = Ext.apply({}, o.r.getData());
                if (newObj.id) {
                  delete newObj.id;
                }
                return newObj;
              });
              wrapper.add({xtype:'grid', store:Ext.create('Ext.data.Store', {data:storeData}), columns:$jscomp$this.flextable.grid.getActionColumnConfig($jscomp$this.moduleId).concat([{dataIndex:'REFERENZ', text:'Referenz', flex:1}, {dataIndex:'MIMETYPE', text:'Mime', flex:1}])});
            }
          }
        }
      }
    }
  });
  this.flextable.load();
}, getAttachments:function(records) {
  var $jscomp$this = this;
  records = records === undefined ? [] : records;
  records = records.map(function(r) {
    return {r:r, attachment:$jscomp$this.flextable.grid.getAttachment(r)};
  }).filter(function(o) {
    return Ext.isDefined(o.attachment) && o.attachment !== null;
  });
  return records;
}, updateTitle:function(num) {
  num = num || 0;
  var prefix = this.baseTitle || 'FLEXTABLE';
  this.setTitle(prefix + ' ( ' + num + ' ) ');
}});
Ext.define('flextable.plugin.detailWindow.Wrapper', {extend:'BpcCommon.plugin.Interface', inheritableStatics:{NAME:'Flextable Plugin', COMPONENT_XTYPE:'flextablePlugin', PLUGIN_ID:'flextable-detailwindow-plugin'}});
Ext.define('flextable.plugin.dynamicContent.Definition', {extend:'BpcCommon.plugin.Interface', inheritableStatics:{NAME:'Flextable Dynamic Content', COMPONENT_XTYPE:'flextableDynamicContent', PLUGIN_ID:'flextable-dynamic-content-plugin'}});
Ext.define('flextable.plugin.dynamicContent.DynamicContent', {extend:'Ext.panel.Panel', alias:'widget.flextableDynamicContent', mixins:['flextable.plugin.BpcPluginMixin'], layout:'fit', instanceId:undefined, requestUrl:undefined, processIdKey:undefined, record:undefined, debugEnabled:false, initComponent:function() {
  this.hidden = true;
  var r = this.getValueFromPluginConfiguration('record', true);
  var instanceId = this.getValueFromPluginConfiguration('instanceId', true);
  var title = this.getValueFromPluginConfiguration('title');
  this.debugEnabled = this.getValueFromPluginConfiguration('debug');
  this.customId = this.getValueFromPluginConfiguration('customId') || 'customId';
  this.customProperties = this.getValueFromPluginConfiguration('customProperties') || {};
  var hookType = this.getValueFromPluginConfiguration('hookType') || 'FILE';
  hookType = hookType.trim().toLowerCase();
  this.title = title || 'Dynamic Content';
  this.hooks = {file:{}};
  this.callParent(arguments);
  if (this.tab) {
    this.tab.hide();
  }
  if (Ext.isDefined(instanceId) && Ext.isDefined(r) && this.hooks.hasOwnProperty(hookType)) {
    this.instanceId = instanceId;
    this.record = r;
    this.hookType = hookType;
    this.configurePlugin();
    this.loadDynamicContent();
    return;
  }
  this.showError(flextable.Support.TR('ERROR_CONFIG_WRONG'));
}, loadDynamicContent:function() {
  var $jscomp$this = this;
  if (this.debugEnabled) {
    this.getDebugData();
    return;
  }
  this.requestData().then(function(json) {
    $jscomp$this.handleWorkflowSuccessResponse(json);
  }, function(response) {
    $jscomp$this.showError('HANDLE');
  });
}, handleWorkflowSuccessResponse:function(json) {
  json = json || {};
  var $jscomp$destructuring$var26 = json;
  var success = $jscomp$destructuring$var26.success;
  var data = $jscomp$destructuring$var26.data;
  var message = $jscomp$destructuring$var26.message;
  if (success && success !== 'false') {
    data = data || [];
    this.showContent(data);
    return;
  }
  this.showError(Ext.valueFrom(message, flextable.Support.TR('ERROR_REQUEST_ERROR')));
}, getDebugData:function() {
  var $jscomp$this = this;
  fetch('/bpc-fe-flextable/resources/examples/dynamic.json').then(function(r) {
    return r.json();
  }).then(function(json) {
    json = json || {};
    var $jscomp$destructuring$var27 = json;
    var success = $jscomp$destructuring$var27.success;
    var data = $jscomp$destructuring$var27.data;
    var message = $jscomp$destructuring$var27.message;
    if (success && success !== 'false') {
      data = data || [];
      $jscomp$this.showContent(data);
      return;
    }
    $jscomp$this.showError(Ext.valueFrom(message, flextable.Support.TR('ERROR_REQUEST_ERROR')));
  });
}, getSetting:function(settingName) {
  return BpcCommon.Api.getSetting(this.instanceId, settingName);
}, configurePlugin:function() {
  this.processIdKey = this.getSetting('column_id');
  this.processIdValue = Ext.String.htmlEncode(this.record.get(this.processIdKey));
  var endpoint = this.getSetting('inubit_vpsendpoint');
  var proxyId = this.getSetting('inubit_proxyId');
  var baseUrl = this.getSetting('inubit_baseUrl');
  this.requestUrl = BpcCommon.Api.getBackendUrl(proxyId) + baseUrl + endpoint;
}, getRequestParams:function() {
  return Ext.apply({}, {hookType:this.hookType, moduleId:this.instanceId, processId:this.processIdValue, customId:this.customId}, this.customProperties);
}, requestData:function() {
  var url = this.requestUrl;
  var params = this.getRequestParams();
  return Ext.Ajax.request({url:url, params:params, method:'POST'}).then(function(response) {
    return Ext.decode(response.responseText, true);
  }, function(response) {
    return response;
  });
}, showError:function(message) {
  this.removeAll();
  this.add({padding:'20 20 20 20', xtype:'displayfield', htmlEncode:true, value:message});
}, showContent:function(data) {
  var $jscomp$this = this;
  data = data === undefined ? [] : data;
  this.removeAll();
  var wrapper = this.getHookTargetCmp();
  if (wrapper) {
    data.map(function(item) {
      wrapper.add($jscomp$this.getViewerForItem(item));
    });
  }
}, getViewerForItem:function(item) {
  var $jscomp$this = this;
  var $jscomp$destructuring$var28 = item;
  var mime = $jscomp$destructuring$var28.mime;
  var base64 = $jscomp$destructuring$var28.base64;
  var fileRaw = $jscomp$destructuring$var28.fileRaw;
  var dataUrl = $jscomp$destructuring$var28.dataUrl;
  var reference = $jscomp$destructuring$var28.reference;
  var loadOnClick = $jscomp$destructuring$var28.loadOnClick;
  var config = $jscomp$destructuring$var28.config;
  var component = $jscomp$destructuring$var28.component;
  var viewerPanel;
  if (component) {
    try {
      var cfg = Ext.apply({}, {xtype:component}, config || {});
      viewerPanel = Ext.create(cfg);
    } catch (e) {
      viewerPanel = Ext.create({xtype:'panel', title:'error', html:'something went wrong during cmp creation'});
    }
  } else {
    dataUrl = dataUrl || '';
    reference = reference || '';
    loadOnClick = [true, false].indexOf(loadOnClick) !== -1 ? loadOnClick : false;
    var decoded = '';
    var remoteFile = reference.length > 0;
    if (!remoteFile) {
      var raw = false;
      var fileData = '';
      if (dataUrl.startsWith('data:')) {
        var parts = dataUrl.split(';');
        var dataAndMime = parts[0].split(':');
        mime = dataAndMime[1];
        var encodingAndBase64 = parts[1].split(',');
        base64 = encodingAndBase64[1];
        if (encodingAndBase64.length === 1) {
          raw = true;
          fileData = encodingAndBase64[0];
        }
      } else {
        raw = true;
        fileData = fileRaw;
      }
      try {
        decoded = raw ? fileData : atob(base64);
      } catch (e$2) {
        decoded = '';
      }
    }
    var title = item.title || this.hookType || '';
    var params = this.getRequestParams();
    if (remoteFile) {
      params.reference = reference;
    }
    item = Ext.apply(item, {slim:true, file:decoded, remote:remoteFile, remoteFileReference:reference, remoteFileRequestData:{url:this.requestUrl, params:params}, remoteContentSourceComponent:this, meta:{mime:mime, directory:'', childid:undefined, processid:''}, record:undefined, fileSource:decoded, fileUrl:dataUrl});
    viewerPanel = flextable.file.getViewer('foo', item);
    viewerPanel.setTitle(title);
    viewerPanel.metaField.setVisible(false);
    viewerPanel.downloadButton.setDisabled(true);
    if (remoteFile && !loadOnClick) {
      viewerPanel.on('activate', function() {
        viewerPanel.debugEnabled = $jscomp$this.debugEnabled;
        viewerPanel.loadRemoteFile();
      });
    }
  }
  return viewerPanel;
}});
Ext.define('flextable.plugin.hooks.Base', {extend:'BpcCommon.plugin.HookContainer', context:undefined, autoInjectPlugins:false, pluginComponentDefinitions:[], hidden:true, assetConfiguration:undefined, initComponent:function() {
  Ext.isDefined(this.assetConfiguration) ? this.context.assetConfig = this.assetConfiguration : undefined;
  var pluginComponents = [];
  try {
    pluginComponents = BpcCommon.Api.getPluginComponents(this, this.context) || [];
  } catch (e) {
    pluginComponents = [];
  }
  if (Ext.isArray(pluginComponents)) {
    this.enrichPlugins(pluginComponents);
  }
  this.callParent(arguments);
}, getPluginDefinitions:function() {
  return this.pluginComponentDefinitions || [];
}, enrichPlugins:function(pluginComponents) {
  pluginComponents = pluginComponents === undefined ? [] : pluginComponents;
  this.pluginComponentDefinitions = pluginComponents.map(function(obj) {
    return obj;
  });
}});
Ext.define('flextable.plugin.hooks.GridActions', {extend:'flextable.plugin.hooks.Base', alias:'widget.flextableGridActionHook', inheritableStatics:{NAME:'Flextable Action Hook', HOOK_ID:'flextable_grid_actions', HOOK_LEVEL:'instance'}});
Ext.define('flextable.plugin.remoteLog.Definition', {extend:'BpcCommon.plugin.Interface', inheritableStatics:{NAME:'Flextable Remote Log', COMPONENT_XTYPE:'flextableRemoteLog', PLUGIN_ID:'flextable-remote-log-plugin'}});
Ext.define('flextable.plugin.remoteLog.RemoteLog', {extend:'Ext.panel.Panel', alias:'widget.flextableRemoteLog', mixins:['flextable.plugin.BpcPluginMixin'], layout:'fit', instanceId:undefined, requestUrl:undefined, processIdKey:undefined, record:undefined, initComponent:function() {
  var $jscomp$this = this;
  var r = this.getValueFromPluginConfiguration('record', true);
  var instanceId = this.getValueFromPluginConfiguration('instanceId', true);
  var title = this.getValueFromPluginConfiguration('title');
  this.title = title || 'Details';
  this.callParent(arguments);
  if (Ext.isDefined(instanceId) && Ext.isDefined(r)) {
    this.instanceId = instanceId;
    this.record = r;
    this.configurePlugin();
    this.requestData().then(function(data) {
      data = data || {};
      if (String(data.success) === 'true') {
        $jscomp$this.showData(data);
        return;
      }
      $jscomp$this.showError(Ext.valueFrom(data.message, flextable.Support.TR('ERROR_REQUEST_ERROR')));
    }, function(response) {
      $jscomp$this.showError('HANDLE');
    });
    return;
  }
  this.showError(flextable.Support.TR('ERROR_CONFIG_WRONG'));
}, getSetting:function(settingName) {
  return BpcCommon.Api.getSetting(this.instanceId, settingName);
}, configurePlugin:function() {
  this.processIdKey = this.getSetting('column_id');
  this.processIdValue = Ext.String.htmlEncode(this.record.get(this.processIdKey));
  var endpoint = this.getSetting('inubit_vpsendpoint');
  var proxyId = this.getSetting('inubit_proxyId');
  var baseUrl = this.getSetting('inubit_baseUrl');
  this.requestUrl = BpcCommon.Api.getBackendUrl(proxyId) + baseUrl + endpoint;
}, requestData:function() {
  var url = this.requestUrl;
  var params = {request:'\x3croot\x3e\x3coperation\x3edetailData\x3c/operation\x3e\x3cprocessID\x3e' + this.processIdValue + '\x3c/processID\x3e\x3c/root\x3e'};
  return Ext.Ajax.request({url:url, params:params, method:'POST'}).then(function(response) {
    return Ext.decode(response.responseText, true);
  }, function(response) {
    return response;
  });
}, showError:function(message) {
  this.removeAll();
  this.add({padding:'20 20 20 20', xtype:'displayfield', htmlEncode:true, value:message});
}, createGridView:function(columns, fields, data) {
  data = data === undefined ? [] : data;
  return Ext.create('Ext.grid.Panel', {flex:1, minWidth:20, columns:columns, store:Ext.create('Ext.data.Store', {fields:fields, data:data}), viewConfig:{enableTextSelection:true, enableColumnHide:true, enableColumnMove:false}});
}, showData:function(data) {
  data = data === undefined ? {} : data;
  this.removeAll();
  var fields = [], columns = (data.columns || []).map(function(c) {
    var $jscomp$destructuring$var29 = c || {};
    var dataIndex = $jscomp$destructuring$var29.dataIndex;
    var text = $jscomp$destructuring$var29.text;
    var width = Ext.Number.from(c.width, 100);
    fields.push(c.dataIndex);
    return Ext.create('Ext.grid.column.Column', {dataIndex:dataIndex, text:text, width:width, hideable:false, sortable:false, align:c.align || 'left', cellAlign:c.cellAlign || 'right'});
  });
  var wrapper = Ext.create({xtype:'container', scrollable:true, layout:{type:'vbox', align:'stretchmax'}, items:[]});
  if ('right' in data.head) {
    wrapper.add({xtype:'container', anchor:'100%', layout:{type:'hbox', align:'stretch'}, padding:10, items:[{width:500, xtype:'displayfield', value:data.head.left}, {width:500, xtype:'displayfield', value:data.head.right}]});
  } else {
    wrapper.add({xtype:'displayfield', value:data.head.left});
  }
  wrapper.add(this.createGridView(columns, fields, data.data));
  this.add(wrapper);
}});
Ext.define('flextable.util.BpcSupport', {singleton:true, getVersionFromPackage:function(packageName) {
  packageName = packageName === undefined ? 'BpcCommon' : packageName;
  var $jscomp$destructuring$var30 = Ext.manifest;
  var packages = $jscomp$destructuring$var30.packages;
  packages = packages || {};
  var common = packages[packageName] || {};
  var $jscomp$destructuring$var31 = common;
  var version = $jscomp$destructuring$var31.version;
  return version || '';
}, isBpcVersion:function(targetVersion) {
  targetVersion = targetVersion === undefined ? 4 : targetVersion;
  try {
    var version = this.getVersionFromPackage();
    var parts = version.split('.');
    return parseInt(parts[0]) === targetVersion;
  } catch (e) {
    return false;
  }
}, versionStartsWith:function(versionPrefix) {
  versionPrefix = versionPrefix === undefined ? '4.1' : versionPrefix;
  return this.getVersionFromPackage().startsWith(versionPrefix);
}});
Ext.define('flextable.util.Dev', {singleton:true, getModuleNameFromClassName:function() {
  var classNameParts = this.$className.split('.');
  return classNameParts[0];
}, showMissingTranslations:function() {
  var store = flextable.util.Store.newLocalStore();
  var map = flextable.Support.getMissingTranslations() || {};
  var data = Object.keys(map).map(function(key) {
    return {key:key, de:'', en:''};
  });
  store.removeAll();
  store.add(data);
  var grid = {xtype:'grid', store:store, selModel:'cellmodel', plugins:{cellediting:{clicksToEdit:1}}, tbar:[{xtype:'tbfill'}, {text:'Export', iconCls:flextable.Support.icon('fa-file-export'), handler:function(b) {
    var s = b.up('grid').store;
    var exportData = [];
    s.each(function(r) {
      var $jscomp$destructuring$var32 = r.getData();
      var key = $jscomp$destructuring$var32.key;
      var de = $jscomp$destructuring$var32.de;
      var en = $jscomp$destructuring$var32.en;
      exportData.push({key:key, de:de, en:en});
    });
    var items = [];
    var de_data = exportData.map(function(item) {
      var $jscomp$destructuring$var33 = item;
      var key = $jscomp$destructuring$var33.key;
      var de = $jscomp$destructuring$var33.de;
      var value = de || '';
      return '"' + key + '" : "' + value + '"';
    });
    var en_data = exportData.map(function(item) {
      var $jscomp$destructuring$var34 = item;
      var key = $jscomp$destructuring$var34.key;
      var en = $jscomp$destructuring$var34.en;
      var value = en || '';
      return '"' + key + '" : "' + value + '"';
    });
    items.push({title:'de', xtype:'panel', layout:'fit', items:[{xtype:'textarea', grow:true, fieldLabel:'MISSING', value:de_data.join(',\n')}]});
    items.push({title:'de', xtype:'panel', layout:'fit', items:[{xtype:'textarea', grow:true, fieldLabel:'MISSING', value:en_data.join(',\n')}]});
    var windowCfg = {xtype:'window', layout:'fit'};
    windowCfg.title = 'MISSING_TRANSLATIONS';
    windowCfg.iconCls = flextable.Support.icon('fa-info');
    windowCfg.items = [{xtype:'tabpanel', items:items}];
    Ext.create(windowCfg).show();
  }}], columns:['key', 'de', 'en'].map(function(dataIndex) {
    var c = {dataIndex:dataIndex, text:dataIndex, flex:1};
    if (dataIndex !== 'key') {
      c.editor = {completeOnEnter:false, field:{xtype:'textfield', allowBlank:false}};
    }
    return c;
  })};
  var windowConfig = Ext.apply({xtype:'window', layout:'fit'}, {title:flextable.Support.TR('MISSING_TRANSLATIONS'), iconCls:flextable.Support.icon('fa-plus'), items:[grid], width:'80%', height:'80%'});
  return Ext.create(windowConfig).show();
}});
Ext.define('flextable.util.Store', {singleton:true, newLocalStore:function(data) {
  data = data === undefined ? [] : data;
  return Ext.create('Ext.data.Store', {data:data});
}});
Ext.define('flextable.view.Main', {extend:'Ext.panel.Panel', alias:'widget.flextableMain', layout:'fit', moduleId:undefined, idKey:undefined, showToolbars:true, initColumns:undefined, isBpcModule:true, header:false, fileViewerMetaHidden:undefined, initComponent:function() {
  var $jscomp$this = this;
  var idKey = this.idKey === false ? undefined : this.idKey || BpcCommon.Api.getSetting(this.moduleId, flextable.Support.keys.id);
  if (this.isBpcModule) {
    this.addBpcModuleFeatures();
  }
  var isDatabaseInstance = true;
  var mainConnection = BpcCommon.Api.getSetting(this.moduleId, 'mainConnection') || '';
  if (mainConnection.trim() === 'backendConnectionHttp') {
    isDatabaseInstance = false;
  }
  this.callParent(arguments);
  flextable.Support.preloadPluginModules(this.moduleId).then(function(config) {
    if (config) {
    }
    if (isDatabaseInstance) {
      $jscomp$this.createTable(idKey);
    } else {
      $jscomp$this.createHttpTable();
    }
    $jscomp$this.load();
  });
}, createTable:function(idKey) {
  this.grid = Ext.create({xtype:'flextableGrid', moduleId:this.moduleId, moduleInstance:this, idKey:idKey, mode:this.idKey === false ? 'details' : undefined});
  this.add(this.grid);
  this.onTableCreated();
}, createHttpTable:function() {
  this.grid = Ext.create({xtype:'flextableHttpGrid', moduleId:this.moduleId, moduleInstance:this});
  this.add(this.grid);
  this.onTableCreated();
}, onTableCreated:function() {
}, addBpcModuleFeatures:function() {
  this.bpcModuleHeader = Ext.createByAlias('widget.flextableModuleHeader', {moduleId:this.moduleId, moduleInstance:this});
}, load:function() {
  this.grid.store.load();
}, getColumn:function(dataIndex) {
  return this.grid.getColumns().filter(function(col) {
    return col.dataIndex === dataIndex;
  }).map(function(col) {
    return {text:col.text || col.header || '', dataIndex:dataIndex, renderer:col.renderer || undefined};
  });
}});
Ext.define('flextable.view.ModuleHeader', {extend:'Ext.container.Container', alias:'widget.flextableModuleHeader', layout:{type:'hbox', align:'stretch'}, moduleId:undefined, initComponent:function() {
  this.items = [{xtype:'toolbar', flex:1, items:[{xtype:'tbfill'}, {handler:this.moduleInstance.load.bind(this.moduleInstance), tooltip:flextable.Support.TR('REFRESH'), iconCls:flextable.Support.icon('fa-sync')}]}];
  this.callParent(arguments);
}});
